function Rating() {}

function getTracker() {
    return require("Piwik/Tracker");
}

var remindMe = true;

var numLaunches = 1;

Rating.prototype.countLaunch = function() {
    if (!this.canRate()) return;
    var rating = Ti.App.Properties.getString("appstore_rating", "");
    if (rating) {
        rating = JSON.parse(rating);
        numLaunches = rating.numLaunches + 1;
        remindMe = rating.remindMe;
        rating = null;
    }
    this.store();
    0 == numLaunches % 40 && this.askUserToRate();
};

Rating.prototype.store = function() {
    var rating = JSON.stringify({
        numLaunches: numLaunches,
        remindMe: remindMe
    });
    Ti.App.Properties.setString("appstore_rating", rating);
};

Rating.prototype.askUserToRate = function() {
    if (!remindMe) return;
    if (!this.canRate()) return;
    var _ = require("L");
    var message = String.format(_("Mobile_RatingPleaseRateUs"), this.getStoreName(), "mobile@piwik.org");
    var buttons = [ _("Mobile_RatingNow"), _("Mobile_RatingNotNow"), _("Mobile_RatingDontRemindMe") ];
    _ = null;
    var dialog = Ti.UI.createAlertDialog({
        message: message,
        buttonNames: buttons,
        cancel: 2
    });
    var that = this;
    dialog.addEventListener("click", function(event) {
        if (event && true !== event.cancel && event.cancel !== event.index) if (0 == event.index) {
            remindMe = false;
            that.rate();
            getTracker().trackEvent({
                title: "Rate now",
                url: "/rating/rate-now"
            });
        } else 1 == event.index && getTracker().trackEvent({
            title: "Rate not now",
            url: "/rating/not-now"
        }); else {
            remindMe = false;
            getTracker().trackEvent({
                title: "Dont remind me",
                url: "/rating/dont-remind-me"
            });
        }
        that.store();
        that = null;
    });
    dialog.show();
};

Rating.prototype.getStoreName = function() {
    var storeName = "";
    return storeName;
};

Rating.prototype.getStoreUrl = function() {
    return "";
};

Rating.prototype.canRate = function() {
    var storeUrl = this.getStoreUrl();
    return !!storeUrl;
};

Rating.prototype.rate = function() {
    if (!this.canRate()) return;
    var storeUrl = this.getStoreUrl();
    if (!storeUrl) return;
    remindMe = false;
    this.store();
    try {
        Ti.Platform.openURL(storeUrl);
    } catch (e) {
        console.warn("Failed to open url " + storeUrl, "Piwik.App.Rating::rate");
    }
};

module.exports = Rating;