function Storage() {
    this.KEY_NOT_FOUND = "IamNotExistingStorageKeyValue";
    this._addStorageKeyPrefix = function(key) {
        return "cache_" + key;
    };
    this.set = function(key, value) {
        console.debug("" + key + value, "Piwik.App.Storage::set");
        if (!key) throw new Error("Missing parameter key");
        var storeEntry = {
            value: value,
            version: Ti.App.version
        };
        key = this._addStorageKeyPrefix(key);
        value = JSON.stringify(storeEntry);
        Ti.App.Properties.setString(key, value);
        storeEntry = null;
        value = null;
    };
    this.get = function(key) {
        console.debug("" + key, "Piwik.App.Storage::get");
        if (!key) throw new Error("Missing parameter key");
        key = this._addStorageKeyPrefix(key);
        if (Ti.App.Properties.hasProperty(key)) {
            var storeEntry = Ti.App.Properties.getString(key);
            storeEntry = JSON.parse(storeEntry);
            if ((!storeEntry.version || Ti.App.version !== storeEntry.version) && 0 !== key.indexOf(this._addStorageKeyPrefix("account"))) {
                console.debug("Store invalid because of new app version" + Ti.App.version, "Piwik.App.Storage::get#invalid");
                Ti.App.Properties.removeProperty(key);
                return this.KEY_NOT_FOUND;
            }
            return storeEntry.value;
        }
        console.debug("Not existing key " + key, "Piwik.App.Storage::get#notExisting");
        return this.KEY_NOT_FOUND;
    };
    this.remove = function(key) {
        console.debug("" + key, "Piwik.App.Storage::remove");
        if (!key) throw new Error("Missing parameter key");
        key = this._addStorageKeyPrefix(key);
        Ti.App.Properties.hasProperty(key) && Ti.App.Properties.removeProperty(key);
    };
}

module.exports = new Storage();