function Locale() {
    this.AVAILABLE_LANGUAGES = {
        be: "Беларуская",
        bg: "Български",
        ca: "Català",
        cs: "Česky",
        cy: "Cymraeg",
        da: "Dansk",
        de: "Deutsch",
        el: "Ελληνικά",
        en: "English",
        es: "Español",
        et: "Eesti keel",
        eu: "Euskara",
        fa: "فارسی",
        fi: "Suomi",
        fr: "Français",
        gl: "Galego",
        hr: "Hrvatski",
        hu: "Magyar",
        id: "Bahasa Indonesia",
        it: "Italiano",
        is: "Íslenska",
        ja: "日本語",
        ko: "한국어",
        lt: "Lietuvių",
        lv: "Latviešu",
        nb: "Norsk (bokmål)",
        nl: "Nederlands",
        nn: "Nynorsk",
        pl: "Polski",
        "pt-br": "Português brasileiro",
        pt: "Português",
        ro: "Română",
        ru: "Русский",
        sk: "Slovensky",
        sq: "Shqip",
        sr: "Srpski",
        sv: "Svenska",
        tr: "Türkçe",
        uk: "Українська",
        "zh-cn": "简体中文",
        "zh-tw": "台灣語"
    };
    this.getAvailableLanguages = function() {
        return this.AVAILABLE_LANGUAGES;
    };
    this.languageExists = function(lang) {
        return this.AVAILABLE_LANGUAGES && this.AVAILABLE_LANGUAGES[lang];
    };
    this.getLocale = function() {
        var settings = Alloy.createCollection("AppSettings").settings();
        var locale = settings.languageCode();
        if (locale && this.languageExists(locale)) {
            settings = null;
            return locale;
        }
        locale = this.getPlatformLocale();
        locale = locale.toLowerCase();
        this.languageExists(locale) || (locale = require("alloy").CFG.settings.locale);
        settings.setLanguageCode(locale);
        return locale;
    };
    this.getPlatformLocale = function() {
        if (Ti.Platform.locale) {
            var locale = Ti.Platform.locale;
            if (locale && locale.getCurrentLocale) return locale.getCurrentLocale();
            if (locale && locale.substr) return locale.substr(0, 2).toLowerCase();
            return locale;
        }
        return "en";
    };
}

module.exports = new Locale();