function Translation() {
    this.translations = null;
    this.DEFAULT_TRANSLATION = require("i18n/default");
    this.getString = function(key) {
        if (this.translations && this.translations[key]) return this.translations[key];
        if (this.DEFAULT_TRANSLATION[key]) return this.DEFAULT_TRANSLATION[key];
        console.error("Missing default translation for key " + key, "Translation::get");
        return key;
    };
    this.load = function() {
        var locale = require("Piwik/Locale");
        locale = locale.getLocale();
        try {
            this.translations = require("i18n/" + locale);
        } catch (e) {
            console.error("Failed to load translations for locale " + locale, "Translation::load");
            var tracker = require("Piwik/Tracker");
            tracker.trackException({
                error: e,
                errorCode: "PiTrLo35"
            });
            Alloy.createController("error", {
                error: e
            }).open();
        }
    };
}

module.exports = new Translation();