function PiwikApiRequest() {
    this.format = "json";
    this.period = "day";
    this.userAuthToken = "anonymous";
    this.method = null;
    this.account = null;
    this.handleAs = "json";
}

var HttpRequest = require("Piwik/Network/HttpRequest");

PiwikApiRequest.prototype = new HttpRequest();

PiwikApiRequest.prototype.setUserAuthToken = function(token) {
    this.userAuthToken = token && "string" === (typeof token).toLowerCase() && token.length > 4 ? token : "anonymous";
};

PiwikApiRequest.prototype.setMethod = function(method) {
    this.method = method;
    method = null;
};

PiwikApiRequest.prototype.setAccount = function(account) {
    this.account = account;
    account = null;
};

PiwikApiRequest.prototype._mixinParameter = function(parameter) {
    parameter || (parameter = {});
    parameter.module || (parameter.module = "API");
    parameter.date || (parameter.date = "today");
    this.userAuthToken && (parameter.token_auth = this.userAuthToken);
    parameter.period || (parameter.period = this.period);
    parameter.format || (parameter.format = this.format);
    parameter.method || (parameter.method = this.method);
    var settings = Alloy.createCollection("AppSettings").settings();
    var language = settings.languageCode();
    settings = null;
    language && (parameter.language = language);
    return parameter;
};

PiwikApiRequest.prototype.isValidResponse = function(response) {
    var _ = require("alloy/underscore")._;
    if (response && _.isObject(response) && response.result && "error" == response.result) {
        if (!this.displayErrorAllowed()) {
            response = null;
            return false;
        }
        this.errorMessageSent = true;
        var L = require("L");
        var message = L("General_InvalidResponse");
        response.message && (message = response.message);
        var alertDialog = Ti.UI.createAlertDialog({
            title: L("General_Error"),
            message: message,
            buttonNames: [ L("General_Ok") ]
        });
        alertDialog.show();
        response = null;
        return false;
    }
    response = null;
    return true;
};

PiwikApiRequest.prototype.send = function() {
    this.parameter || (this.parameter = {});
    this.parameter = this._mixinParameter(this.parameter);
    this.handle();
};

module.exports = PiwikApiRequest;