function PiwikGraph() {
    var locale = require("Piwik/Locale").getLocale();
    this.generateUrl = function(graphUrl, account) {
        if (!graphUrl) return "";
        var parameter = {
            language: locale
        };
        var requestUrl = "";
        for (var paramName in parameter) requestUrl += paramName + "=" + parameter[paramName] + "&";
        graphUrl = graphUrl + "&" + network.encodeUrlParams(requestUrl);
        graphUrl = account.getBasePath() + graphUrl;
        account = null;
        return graphUrl;
    };
    this.addSortOrder = function(graphUrl, sortOrder) {
        if (!sortOrder) return graphUrl;
        var sortOrderParams = {
            filter_sort_column: sortOrder,
            column: sortOrder,
            columns: sortOrder
        };
        return this.setParams(graphUrl, sortOrderParams);
    };
    this.setParams = function(graphUrl, params) {
        if (!graphUrl) return "";
        var urlGetParams = "";
        for (var paramName in params) {
            urlGetParams && (urlGetParams += "&");
            urlGetParams += paramName + "=" + params[paramName];
        }
        var separator = "&";
        var lastChar = graphUrl.substr(graphUrl.length - 1, 1);
        "&" == lastChar && (separator = "");
        graphUrl = graphUrl + separator + network.encodeUrlParams(urlGetParams);
        params = null;
        return graphUrl;
    };
    this.appendSize = function(graphUrl, width, height, hires) {
        var parameter = {
            width: width,
            height: height
        };
        for (var index in Alloy.CFG.piwik.graph) parameter[index] = Alloy.CFG.piwik.graph[index];
        if (hires && false) {
            parameter.legendFontSize = 2 * parameter.fontSize;
            parameter.fontSize = 2 * parameter.fontSize;
            parameter.width = 2 * parameter.width;
            parameter.height = 2 * parameter.height;
        } else if (hires && false) {
            parameter.legendFontSize = Math.round(1.5 * parameter.fontSize);
            parameter.fontSize = Math.round(1.5 * parameter.fontSize);
        }
        parameter.cacherand = Math.floor(9999999 * Math.random());
        graphUrl = this.setParams(graphUrl, parameter);
        parameter = null;
        return graphUrl;
    };
    this.getSparklineUrl = function(siteId, accessUrl, tokenAuth) {
        var url = "?module=MultiSites&action=getEvolutionGraph&period=day&date=last30&evolutionBy=visits";
        url += "&columns[]=nb_visits&idSite=" + siteId + "&idsite=" + siteId + "&viewDataTable=sparkline";
        url += "&token_auth=" + tokenAuth;
        url += "&width=200&height=50";
        url += "&cacherand=" + Math.floor(9999999 * Math.random());
        return accessUrl + network.encodeUrlParams(url);
    };
}

var Alloy = require("alloy");

var network = require("Piwik/Network");

module.exports = new PiwikGraph();