function Profiler() {
    this.ENABLED = false;
    this.time = null;
    this.step = function() {
        if (!this.ENABLED) return;
        if (!this.time) {
            this.time = new Date().getTime();
            return;
        }
        var now = new Date().getTime();
        Ti.API.debug("Time: " + (now - this.time) + "ms");
        Ti.API.debug("Free mem: " + Ti.Platform.availableMemory / 1e3 + "kb");
        this.time = now;
    };
    this.start = function(key) {
        if (!this.ENABLED) return;
        this["profilingMem" + key] = "" + Ti.Platform.availableMemory;
        this["profilingDate" + key] = new Date().getTime();
    };
    this.end = function(key) {
        if (!this.ENABLED) return;
        var now = new Date().getTime();
        if ("undefined" == typeof this["profilingDate" + key] || !this["profilingDate" + key]) {
            Ti.API.warn('You have to call this.start("' + key + '")');
            return;
        }
        var startTime = this["profilingDate" + key];
        var startMem = this["profilingMem" + key];
        delete this["profilingDate" + key];
        Ti.API.warn("" + key + ": " + (now - startTime) + "ms");
        Ti.API.warn("" + key + " Start free mem: " + startMem + "b");
        Ti.API.warn("" + key + " Now free mem: " + Ti.Platform.availableMemory + "b");
    };
}

module.exports = new Profiler();