function TrackerQueue() {
    var queue = [];
    var isQueueRunning = false;
    var numTracksToday = 0;
    var dateStringToday = "";
    var delayInMs = 2e3;
    this.isNewDay = function() {
        var now = new Date();
        var dateNow = now.toDateString();
        dateStringToday || (dateStringToday = dateNow);
        if (dateNow != dateStringToday) {
            dateStringToday = dateNow;
            return true;
        }
        return false;
    };
    this.offer = function(parameter) {
        if (!parameter) return;
        this.isNewDay() && (numTracksToday = 0);
        if (maxTracksPerDay && numTracksToday >= maxTracksPerDay) return;
        numTracksToday++;
        queue.push(parameter);
        parameter = null;
        this.isRunning() || this.start();
    };
    this.isEmpty = function() {
        return !queue || !queue.length;
    };
    this.poll = function() {
        if (this.isEmpty()) return;
        return queue.shift();
    };
    this.clear = function() {
        this.isEmpty() || (queue = []);
    };
    this.start = function() {
        isQueueRunning = true;
        this.dispatch();
    };
    this.stop = function() {
        isQueueRunning = false;
    };
    this.isRunning = function() {
        return isQueueRunning;
    };
    this.delayNextDispatch = function() {
        if (!this.isRunning()) return;
        if (this.isEmpty()) {
            this.pause();
            return;
        }
        setTimeout(function(that) {
            return function() {
                that.dispatch();
                that = null;
            };
        }(this), delayInMs);
    };
    this.pause = function() {
        if (!this.isRunning()) return;
        setTimeout(function(that) {
            return function() {
                that.isEmpty() ? that.stop() : that.dispatch();
                that = null;
            };
        }(this), delayInMs);
    };
    this.dispatch = function() {
        if (!this.isRunning()) return;
        if (!Ti.Network || !Ti.Network.online) {
            this.stop();
            return;
        }
        if (this.isEmpty()) {
            this.pause();
            return;
        }
        var parameter = this.poll();
        var TrackerRequest = require("Piwik/Network/TrackerRequest");
        var tracker = new TrackerRequest();
        tracker.setParameter(parameter);
        tracker.send();
        tracker = null;
        parameter = null;
        this.delayNextDispatch();
    };
}

var maxTracksPerDay = require("alloy").CFG.tracking.maxTracksPerDay;

module.exports = new TrackerQueue();