function openEntrySite(account) {
    var entrySiteId = account.entrySiteId();
    var site = Alloy.createCollection("PiwikWebsitesById");
    site.fetch({
        params: {
            idSite: entrySiteId
        },
        account: account,
        success: function(sites) {
            onSiteSelected({
                site: sites.entrySite(),
                account: account
            });
        },
        error: function() {}
    });
}

function onSiteSelected(event) {
    onSiteSelectedCallback(event.site, event.account);
}

function openDashboard() {
    var dashboard = Alloy.createController("all_websites_dashboard");
    dashboard.on("websiteChosen", onSiteSelected);
    dashboard.on("websiteChosen", function() {
        this.close();
    });
    dashboard.open();
}

function updateDefaultReportDateInSession(accountModel) {
    var reportDate = new (require("report/date"))();
    reportDate.setReportDate(accountModel.getDefaultReportDate());
    require("session").setReportDate(reportDate);
}

var onSiteSelectedCallback = null;

exports.selectWebsite = function(accountModel, callback) {
    onSiteSelectedCallback = callback;
    accountModel.select(function(account) {
        updateDefaultReportDateInSession(account);
        account.startWithAllWebsitesDashboard() ? openDashboard(account) : openEntrySite(account);
    });
};