function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function trackWindowRequest() {
        require("Piwik/Tracker").setCustomVariable(1, "period", period, "page");
        require("Piwik/Tracker").trackWindow("Date Chooser", "date-chooser");
    }
    function onOpen() {
        trackWindowRequest();
    }
    function setPeriod(selectedPeriod) {
        if (!selectedPeriod) return;
        period = selectedPeriod;
        if (!$.toDateContainer || !$.fromDateLabel) return;
        if ("range" == period) {
            $.toDateContainer.show();
            $.fromDateLabel.text = L("General_DateRangeFrom_js");
            $.toDateLabel.text = L("General_DateRangeTo_js");
        } else {
            $.toDateContainer.hide();
            $.fromDateLabel.text = L("General_Date");
        }
    }
    function onPeriodChange(event) {
        if (!event || !event.row || !event.row.period) return;
        setPeriod(event.row.period);
    }
    function closeWindow() {
        require("layout").close($.index);
    }
    function doChooseDate() {
        try {
            var fromDate = $.fromDatePicker.value;
            var toDate = $.toDatePicker.value;
            var myEvent = {
                from: fromDate,
                to: toDate,
                period: period,
                type: "onSet"
            };
            $.trigger("onSet", myEvent);
            closeWindow();
        } catch (e) {
            console.warn("Failed to close site chooser window", "datechooser::dochoosedate", e);
        }
    }
    function preSelectPeriod(initialPeriod) {
        var PiwikDates = require("report/date");
        var piwikDate = new PiwikDates();
        var periods = piwikDate.getAvailablePeriods();
        var index = 0;
        for (period in periods) {
            if (period == initialPeriod) {
                $.periodPicker.setSelectedRow(0, index, false);
                return;
            }
            index++;
        }
        $.periodPicker.setSelectedRow(0, 0, false);
    }
    function initFromDatePicker() {
        var params = JSON.parse(JSON.stringify(args));
        params.value = args.from || new Date();
        $.fromDatePicker.applyProperties(params);
    }
    function initToDatePicker() {
        var params = JSON.parse(JSON.stringify(args));
        params.value = args.to || new Date();
        $.toDatePicker.applyProperties(params);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.index = Ti.UI.createWindow({
        barImage: "navbar.png",
        backgroundColor: "#FFFFFF",
        barColor: "#CD1628",
        title: L("General_ChooseDate"),
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
    $.__views.updateButton = Ti.UI.createButton({
        title: L("CoreUpdater_UpdateTitle"),
        id: "updateButton"
    });
    doChooseDate ? $.__views.updateButton.addEventListener("click", doChooseDate) : __defers["$.__views.updateButton!click!doChooseDate"] = true;
    $.__views.index.rightNavButton = $.__views.updateButton;
    $.__views.__alloyId53 = Ti.UI.createScrollView({
        backgroundColor: "white",
        contentWidth: "auto",
        contentHeight: "auto",
        layout: "vertical",
        showVerticalScrollIndicator: true,
        showHorizontalScrollIndicator: true,
        id: "__alloyId53"
    });
    $.__views.index.add($.__views.__alloyId53);
    $.__views.periodContainer = Ti.UI.createView({
        left: 0,
        width: Ti.UI.FILL,
        top: 16,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "periodContainer"
    });
    $.__views.__alloyId53.add($.__views.periodContainer);
    $.__views.periodLabel = Ti.UI.createLabel({
        color: "#333333",
        left: 16,
        font: {
            fontSize: 18
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        ellipsize: false,
        wordWrap: true,
        title: L("General_Period"),
        id: "periodLabel"
    });
    $.__views.periodContainer.add($.__views.periodLabel);
    var __alloyId54 = [];
    $.__views.periodPicker = Ti.UI.createPicker({
        top: 8,
        left: 16,
        right: 16,
        height: 150,
        id: "periodPicker"
    });
    $.__views.periodContainer.add($.__views.periodPicker);
    $.__views.period_day = Ti.UI.createPickerRow({
        title: L("CoreHome_PeriodDay"),
        period: "day",
        id: "period_day"
    });
    __alloyId54.push($.__views.period_day);
    $.__views.period_week = Ti.UI.createPickerRow({
        title: L("CoreHome_PeriodWeek"),
        period: "week",
        id: "period_week"
    });
    __alloyId54.push($.__views.period_week);
    $.__views.period_month = Ti.UI.createPickerRow({
        title: L("CoreHome_PeriodMonth"),
        period: "month",
        id: "period_month"
    });
    __alloyId54.push($.__views.period_month);
    $.__views.period_year = Ti.UI.createPickerRow({
        title: L("CoreHome_PeriodYear"),
        period: "year",
        id: "period_year"
    });
    __alloyId54.push($.__views.period_year);
    $.__views.period_range = Ti.UI.createPickerRow({
        title: L("CoreHome_PeriodRange"),
        period: "range",
        id: "period_range"
    });
    __alloyId54.push($.__views.period_range);
    $.__views.periodPicker.add(__alloyId54);
    onPeriodChange ? $.__views.periodPicker.addEventListener("change", onPeriodChange) : __defers["$.__views.periodPicker!change!onPeriodChange"] = true;
    $.__views.fromDateContainer = Ti.UI.createView({
        left: 0,
        width: Ti.UI.FILL,
        top: 16,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "fromDateContainer"
    });
    $.__views.__alloyId53.add($.__views.fromDateContainer);
    $.__views.fromDateLabel = Ti.UI.createLabel({
        color: "#333333",
        left: 16,
        font: {
            fontSize: 18
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        ellipsize: false,
        wordWrap: true,
        title: L("General_Date"),
        id: "fromDateLabel"
    });
    $.__views.fromDateContainer.add($.__views.fromDateLabel);
    $.__views.fromDatePicker = Ti.UI.createPicker({
        type: Ti.UI.PICKER_TYPE_DATE,
        top: 8,
        left: 16,
        right: 16,
        height: 50,
        id: "fromDatePicker"
    });
    $.__views.fromDateContainer.add($.__views.fromDatePicker);
    $.__views.toDateContainer = Ti.UI.createView({
        left: 0,
        width: Ti.UI.FILL,
        top: 16,
        layout: "vertical",
        height: Ti.UI.SIZE,
        id: "toDateContainer"
    });
    $.__views.__alloyId53.add($.__views.toDateContainer);
    $.__views.toDateLabel = Ti.UI.createLabel({
        color: "#333333",
        left: 16,
        font: {
            fontSize: 18
        },
        textAlign: Ti.UI.TEXT_ALIGNMENT_LEFT,
        ellipsize: false,
        wordWrap: true,
        title: L("General_DateRangeTo_js"),
        id: "toDateLabel"
    });
    $.__views.toDateContainer.add($.__views.toDateLabel);
    $.__views.toDatePicker = Ti.UI.createPicker({
        type: Ti.UI.PICKER_TYPE_DATE,
        top: 8,
        left: 16,
        right: 16,
        height: 50,
        id: "toDatePicker"
    });
    $.__views.toDateContainer.add($.__views.toDatePicker);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    var period = args.period || "day";
    exports.open = function() {
        preSelectPeriod(period);
        setPeriod(period);
        initFromDatePicker();
        initToDatePicker();
        require("layout").open($.index);
    };
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.updateButton!click!doChooseDate"] && $.__views.updateButton.addEventListener("click", doChooseDate);
    __defers["$.__views.periodPicker!change!onPeriodChange"] && $.__views.periodPicker.addEventListener("change", onPeriodChange);
    __defers["$.__views.updateButton!click!doChooseDate"] && $.__views.updateButton.addEventListener("click", doChooseDate);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;