function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function onOpen() {
        require("Piwik/Tracker").trackWindow("Give Feedback", "give-feedback");
    }
    function onClose() {
        $.destroy();
    }
    function toggleReportChooserVisibility() {
        require("report/chooser").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Chooser",
            url: "/give-feedback/toggle/report-chooser"
        });
    }
    function platformInfo() {
        return String.format("%s %s %s (%s)", "mobileweb", "" + Ti.Platform.version, "" + Ti.Platform.model, "" + Ti.Platform.locale);
    }
    function versionInfo() {
        return String.format("%s - %s %s", "" + Ti.App.version, "" + Ti.version, "" + Ti.buildHash);
    }
    function doSendEmailFeedback() {
        require("commands/sendEmailFeedback").execute();
        require("Piwik/Tracker").trackEvent({
            title: "Email Us",
            url: "/give-feedback/email-us"
        });
    }
    function doRateApp() {
        require("commands/rateApp").execute();
        require("Piwik/Tracker").trackEvent({
            title: "Rate-App",
            url: "/give-feedback/rate-app"
        });
    }
    function doParticipate() {
        require("commands/openLink").execute("http://piwik.org/contribute/");
    }
    function createRow(params) {
        return Alloy.createWidget("org.piwik.tableviewrow", null, params).getRow();
    }
    function createSection(params) {
        return Alloy.createWidget("org.piwik.tableviewsection", null, params).getSection();
    }
    function render() {
        var rows = [];
        var row = createRow({
            title: "Email Us",
            description: "Send us feedback, report a bug or a feature wish."
        });
        row.addEventListener("click", doSendEmailFeedback);
        rows.push(row);
        var appRating = new (require("Piwik/App/Rating"))();
        if (appRating.canRate()) {
            row = createRow({
                title: "Rate us on the App Store",
                description: "Piwik Mobile App is a Free Software, we would really appreciate if you took 1 minute to rate us."
            });
            row.addEventListener("click", doRateApp);
            rows.push(row);
        }
        row = createRow({
            title: "Learn how you can participate",
            description: "Piwik is a project made by the community, you can participate in the Piwik Mobile App or Piwik."
        });
        row.addEventListener("click", doParticipate);
        rows.push(row);
        rows.push(createSection({
            title: "About",
            style: "native"
        }));
        rows.push(createRow({
            title: "Version",
            description: versionInfo()
        }));
        rows.push(createRow({
            title: "Platform",
            description: platformInfo()
        }));
        $.feedbackTable.setData(rows);
        rows = null;
        row = null;
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.index = Ti.UI.createWindow({
        barImage: "navbar.png",
        backgroundColor: "#FFFFFF",
        barColor: "#CD1628",
        title: L("General_GiveUsYourFeedback"),
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    onClose ? $.__views.index.addEventListener("close", onClose) : __defers["$.__views.index!close!onClose"] = true;
    onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
    if (true && !Alloy.isTablet) {
        $.__views.__alloyId67 = Ti.UI.createButton({
            backgroundImage: "ic_action_menu.png",
            width: 32,
            height: 32,
            id: "__alloyId67"
        });
        toggleReportChooserVisibility ? $.__views.__alloyId67.addEventListener("click", toggleReportChooserVisibility) : __defers["$.__views.__alloyId67!click!toggleReportChooserVisibility"] = true;
        $.__views.index.leftNavButton = $.__views.__alloyId67;
    }
    $.__views.feedbackTable = Ti.UI.createTableView({
        id: "feedbackTable"
    });
    $.__views.index.add($.__views.feedbackTable);
    exports.destroy = function() {};
    _.extend($, $.__views);
    exports.open = function() {
        render();
        require("layout").open($.index);
    };
    exports.close = function() {
        require("layout").close($.index);
    };
    __defers["$.__views.index!close!onClose"] && $.__views.index.addEventListener("close", onClose);
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.__alloyId67!click!toggleReportChooserVisibility"] && $.__views.__alloyId67.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.__alloyId69!click!toggleReportChooserVisibility"] && $.__views.__alloyId69.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.headerBar!homeIconItemSelected!toggleReportChooserVisibility"] && $.__views.headerBar.on("homeIconItemSelected", toggleReportChooserVisibility);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;