function Controller() {
    function width(image) {
        return require("ui/helper").getWidth(image);
    }
    function height(image) {
        return require("ui/helper").getHeight(image);
    }
    function getGraphOptions() {
        return {
            imageGraphUrl: imageGraphUrl,
            imageGraphEvolutionUrl: imageGraphEvolutionUrl,
            reportName: reportName,
            reportDate: reportDate
        };
    }
    function showDetail() {
        var detailGraph = Alloy.createController("graph_detail", getGraphOptions());
        detailGraph.open();
    }
    function updateImage(graphUrl) {
        var graph = require("Piwik/PiwikGraph");
        var imageWithSize = graph.appendSize(graphUrl, width($.image.getView()), height($.image.getView()), false);
        console.log(imageWithSize);
        $.image.getView() && ($.image.getView().image = imageWithSize);
    }
    function addGraphSwitcher(graphSwitcher) {
        graphSwitcher.addSwitchGraph(false);
        $.index.add(graphSwitcher.getView());
        graphSwitcher.on("switch", function(event) {
            if (!event || !event.graphUrl) return;
            updateImage(event.graphUrl);
            graphSwitcher.toggleVisibility();
            $.showDetailIcon.hide();
        });
        $.image.getView().addEventListener("click", function() {
            if (!graphSwitcher) return;
            graphSwitcher.toggleVisibility();
        });
        graphSwitcher.fadeOut();
    }
    function completeGraphUrl(graphUrl, processedReportCollection, accountModel) {
        if (!graphUrl) return "";
        var graph = require("Piwik/PiwikGraph");
        graphUrl = graph.addSortOrder(graphUrl, processedReportCollection.getSortOrder());
        graphUrl = graph.generateUrl(graphUrl, accountModel);
        return graphUrl;
    }
    function toggleDetailIcon() {
        $.showDetailIcon && $.showDetailIcon.visible ? $.showDetailIcon.hide() : $.showDetailIcon && !$.showDetailIcon.visible && $.showDetailIcon.show();
    }
    function fadeOutDetailIcon() {
        if (!$.showDetailIcon) return;
        $.showDetailIcon.hide();
        $.showDetailIcon.opacity = 1;
    }
    function animateFadeOutDetailIcon() {
        if (!$.showDetailIcon) return;
        $.showDetailIcon.animate({
            opacity: 0,
            delay: 600,
            duration: 600
        }, fadeOutDetailIcon);
    }
    function areGraphsEnabled() {
        var settings = Alloy.createCollection("AppSettings").settings();
        return settings.areGraphsEnabled();
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.index = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        backgroundColor: "#efefef",
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    $.__views.image = Alloy.createWidget("org.piwik.imageview", "widget", {
        top: 15,
        height: 150,
        left: 10,
        right: 10,
        zIndex: 5,
        bottom: 10,
        image: "graphDefault.png",
        id: "image",
        __parentSymbol: $.__views.index
    });
    $.__views.image.setParent($.__views.index);
    $.__views.showDetailIcon = Ti.UI.createImageView({
        image: "ic_action_fullscreen.png",
        backgroundSelectedColor: "#FFC700",
        backgroundFocusedColor: "#FFC700",
        backgroundColor: "#ffffff",
        bottom: 8,
        right: 8,
        width: 32,
        height: 32,
        zIndex: 10,
        id: "showDetailIcon"
    });
    $.__views.index.add($.__views.showDetailIcon);
    showDetail ? $.__views.showDetailIcon.addEventListener("click", showDetail) : __defers["$.__views.showDetailIcon!click!showDetail"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    var imageGraphUrl;
    var imageGraphEvolutionUrl;
    var reportName = "";
    var reportDate = "";
    exports.update = function(processedReportCollection, accountModel) {
        if (!areGraphsEnabled()) {
            $.index.height = 0;
            $.index.hide();
            $.destroy();
            $.off();
            return;
        }
        imageGraphUrl = processedReportCollection.getImageGraphUrl();
        reportName = processedReportCollection.getReportName();
        reportDate = processedReportCollection.getReportDate();
        imageGraphEvolutionUrl = processedReportCollection.getEvolutionImageGraphUrl();
        imageGraphUrl = completeGraphUrl(imageGraphUrl, processedReportCollection, accountModel);
        imageGraphEvolutionUrl = completeGraphUrl(imageGraphEvolutionUrl, processedReportCollection, accountModel);
        var graphSwitcher = Alloy.createController("graph_switcher", getGraphOptions());
        if (!graphSwitcher.currentGraphUrl()) {
            $.index.hide();
            return;
        }
        $.index.show();
        graphSwitcher.canSwitch() && addGraphSwitcher(graphSwitcher);
        updateImage(graphSwitcher.currentGraphUrl());
        animateFadeOutDetailIcon();
        $.image.getView().addEventListener("click", toggleDetailIcon);
    };
    __defers["$.__views.showDetailIcon!click!showDetail"] && $.__views.showDetailIcon.addEventListener("click", showDetail);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;