function Controller() {
    function getViewWidth() {
        $.index && $.index.size && $.index.size.width && $.index.size.width;
        return Ti.Platform.displayCaps.platformWidth;
    }
    function getViewHeight() {
        if ($.index && $.index.size && $.index.size.height) return $.index.size.height;
        return Ti.Platform.displayCaps.platformHeight;
    }
    function getPictureWidth() {
        return getViewWidth() - 20;
    }
    function getPictureHeight() {
        var height = getViewHeight();
        var pictureHeight = 0;
        pictureHeight = require("alloy").isTablet ? height - Math.floor(height / 4) - 20 : height - 20;
        return pictureHeight;
    }
    function getGraphUrlWithSize(width, height) {
        if (!graphSwitcher.currentGraphUrl()) return "";
        var graph = require("Piwik/PiwikGraph");
        var graphUrlWithSize = graph.appendSize(graphSwitcher.currentGraphUrl(), width, height, true);
        var params = {
            showMetricTitle: 1,
            showLegend: 1,
            legendAppendMetric: 1
        };
        require("alloy").isTablet && (params.backgroundColor = "ffffff");
        graphUrlWithSize = graph.setParams(graphUrlWithSize, params);
        graph = null;
        return graphUrlWithSize;
    }
    function rotateImage() {
        var pictureWidth = getPictureWidth();
        var pictureHeight = getPictureHeight();
        $.graph.width = pictureWidth;
        $.graph.height = pictureHeight;
        $.graph.image = getGraphUrlWithSize(pictureWidth, pictureHeight);
    }
    function trackWindowRequest() {
        require("Piwik/Tracker").setCustomVariable(1, "reportName", reportName, "page");
        require("Piwik/Tracker").trackWindow("Graph Detail", "graph/detail");
    }
    function onOpen() {
        trackWindowRequest();
    }
    function destroy() {
        require("alloy").isTablet || Ti.Gesture.removeEventListener("orientationchange", rotateImage);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    if (!Alloy.isTablet) {
        $.__views.index = Ti.UI.createWindow(function() {
            var o = {};
            _.extend(o, {
                barImage: "navbar.png",
                backgroundColor: "#FFFFFF",
                barColor: "#CD1628"
            });
            Alloy.isTablet && _.extend(o, {
                backgroundColor: "white"
            });
            _.extend(o, {});
            Alloy.isHandheld && _.extend(o, {
                backgroundColor: "#efefef"
            });
            _.extend(o, {
                modal: true,
                navBarHidden: true,
                id: "index"
            });
            return o;
        }());
        $.__views.index && $.addTopLevelView($.__views.index);
        destroy ? $.__views.index.addEventListener("close", destroy) : __defers["$.__views.index!close!destroy"] = true;
        onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
        $.__views.graphWidget = Alloy.createWidget("org.piwik.imageview", "widget", {
            touchEnabled: false,
            canScale: false,
            hires: false,
            defaultImage: "graphDefault.png",
            enableZoomControls: false,
            left: 10,
            right: 10,
            top: 10,
            bottom: 10,
            id: "graphWidget",
            __parentSymbol: $.__views.index
        });
        $.__views.graphWidget.setParent($.__views.index);
    }
    if (Alloy.isTablet) {
        $.__views.index = Ti.UI.createWindow(function() {
            var o = {};
            _.extend(o, {
                barImage: "navbar.png",
                backgroundColor: "#FFFFFF",
                barColor: "#CD1628"
            });
            Alloy.isTablet && _.extend(o, {
                backgroundColor: "white"
            });
            _.extend(o, {});
            Alloy.isHandheld && _.extend(o, {
                backgroundColor: "#efefef"
            });
            _.extend(o, {
                modal: true,
                navBarHidden: true,
                id: "index"
            });
            return o;
        }());
        $.__views.index && $.addTopLevelView($.__views.index);
        destroy ? $.__views.index.addEventListener("close", destroy) : __defers["$.__views.index!close!destroy"] = true;
        $.__views.topContainer = Ti.UI.createView({
            top: 0,
            left: 0,
            right: 0,
            backgroundColor: "#cccccc",
            id: "topContainer"
        });
        $.__views.index.add($.__views.topContainer);
        $.__views.__alloyId70 = Ti.UI.createView({
            layout: "vertical",
            height: Ti.UI.SIZE,
            width: Ti.UI.SIZE,
            left: 0,
            right: 0,
            id: "__alloyId70"
        });
        $.__views.topContainer.add($.__views.__alloyId70);
        $.__views.reportName = Ti.UI.createLabel({
            color: "#333333",
            text: " ",
            ellipsize: true,
            wordWrap: false,
            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
            left: 20,
            right: 20,
            font: {
                fontSize: 48
            },
            id: "reportName"
        });
        $.__views.__alloyId70.add($.__views.reportName);
        $.__views.reportDate = Ti.UI.createLabel({
            color: "#666666",
            text: " ",
            ellipsize: true,
            wordWrap: false,
            textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
            top: 25,
            left: 20,
            right: 20,
            font: {
                fontSize: 36
            },
            id: "reportDate"
        });
        $.__views.__alloyId70.add($.__views.reportDate);
        $.__views.__alloyId71 = Ti.UI.createView({
            bottom: 0,
            height: 2,
            backgroundColor: "#bbbbbb",
            left: 0,
            right: 0,
            id: "__alloyId71"
        });
        $.__views.index.add($.__views.__alloyId71);
        $.__views.bottomContainer = Ti.UI.createView({
            bottom: 0,
            left: 0,
            right: 0,
            id: "bottomContainer"
        });
        $.__views.index.add($.__views.bottomContainer);
        $.__views.graphWidget = Alloy.createWidget("org.piwik.imageview", "widget", {
            touchEnabled: false,
            canScale: false,
            hires: false,
            defaultImage: "graphDefault.png",
            enableZoomControls: false,
            left: 10,
            right: 10,
            top: 10,
            bottom: 10,
            id: "graphWidget",
            __parentSymbol: $.__views.bottomContainer
        });
        $.__views.graphWidget.setParent($.__views.bottomContainer);
    }
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    var reportName = args.reportName || " ";
    var reportDate = args.reportDate || " ";
    $.graph = $.graphWidget.getView();
    var graphSwitcher = Alloy.createController("graph_switcher", args);
    graphSwitcher.addSwitchGraph(true);
    $.index.add(graphSwitcher.getView());
    graphSwitcher.on("close", function() {
        $.index.close();
    });
    graphSwitcher.on("switch", function() {
        $.graph.image = getGraphUrlWithSize(getPictureWidth(), getPictureHeight());
    });
    $.index.addEventListener("click", function() {
        if (!graphSwitcher) return;
        graphSwitcher.toggleVisibility();
    });
    {
        Ti.Platform.displayCaps.platformHeight - getViewHeight();
    }
    var pictureWidth = getPictureWidth();
    var pictureHeight = getPictureHeight();
    var graphUrlWithSize = getGraphUrlWithSize(pictureWidth, pictureHeight);
    $.graph.image = graphUrlWithSize;
    if (require("alloy").isTablet) {
        var quarter = Math.floor(getViewHeight() / 4);
        $.topContainer.height = quarter;
        $.bottomContainer.top = quarter;
        args.reportName && ($.reportName.text = "" + reportName);
        args.reportDate && ($.reportDate.text = "" + reportDate);
    } else Ti.Gesture.addEventListener("orientationchange", rotateImage);
    exports.open = function() {
        $.index.open();
    };
    __defers["$.__views.index!close!destroy"] && $.__views.index.addEventListener("close", destroy);
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.index!close!destroy"] && $.__views.index.addEventListener("close", destroy);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;