function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function getSettings() {
        return Alloy.createCollection("AppSettings").settings();
    }
    function nextGraphUrl() {
        if (currentUrl == staticUrl) {
            currentUrl = evolutionUrl;
            getSettings().setPreferEvolutionGraphs(true);
            require("Piwik/Tracker").trackEvent({
                title: "Switch Graph Evolution",
                url: "/graph/switch/evolution"
            });
        } else if (currentUrl == evolutionUrl) {
            currentUrl = staticUrl;
            getSettings().setPreferEvolutionGraphs(false);
            require("Piwik/Tracker").trackEvent({
                title: "Switch Graph Static",
                url: "/graph/switch/static"
            });
        }
        return currentUrl;
    }
    function getNextGraphType() {
        if (currentUrl == evolutionUrl) return L("Mobile_StaticGraph");
        return L("Mobile_EvolutionGraph");
    }
    function getPreferredGraphUrl() {
        if (!evolutionUrl && staticUrl) return staticUrl;
        if (!staticUrl && evolutionUrl) return evolutionUrl;
        if (!staticUrl && !evolutionUrl) return "";
        if (getSettings().preferEvolutionGraphs()) return evolutionUrl;
        return staticUrl;
    }
    function doSwitchGraph() {
        $.trigger("switch", {
            graphUrl: nextGraphUrl()
        });
        $.switchButton.title = getNextGraphType();
    }
    function doClose() {
        $.trigger("close", {});
    }
    function canSwitch() {
        if (staticUrl == evolutionUrl) return false;
        return staticUrl && evolutionUrl;
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.index = Ti.UI.createView({
        opacity: .9,
        visible: true,
        top: 0,
        left: 0,
        right: 0,
        backgroundColor: "#bbbbbb",
        height: 40,
        zIndex: 999,
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    $.__views.closeButton = Ti.UI.createButton({
        color: "#333333",
        left: 16,
        top: 1,
        height: 38,
        title: L("General_Close"),
        id: "closeButton"
    });
    $.__views.index.add($.__views.closeButton);
    doClose ? $.__views.closeButton.addEventListener("click", doClose) : __defers["$.__views.closeButton!click!doClose"] = true;
    $.__views.switchButton = Ti.UI.createButton({
        color: "#333333",
        right: 16,
        top: 1,
        height: 38,
        id: "switchButton"
    });
    $.__views.index.add($.__views.switchButton);
    doSwitchGraph ? $.__views.switchButton.addEventListener("click", doSwitchGraph) : __defers["$.__views.switchButton!click!doSwitchGraph"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    var staticUrl = args.imageGraphUrl || "";
    var evolutionUrl = args.imageGraphEvolutionUrl || "";
    var currentUrl = getPreferredGraphUrl();
    exports.canSwitch = canSwitch;
    exports.currentGraphUrl = function() {
        return currentUrl;
    };
    exports.toggleVisibility = function() {
        $.index && $.index.visible ? $.index.hide() : $.index && !$.index.visible && $.index.show();
    };
    exports.fadeOut = function() {
        $.index.animate({
            opacity: 0,
            delay: 600,
            duration: 600
        }, function() {
            $.index.hide();
            $.index.opacity = .7;
        });
    };
    exports.addSwitchGraph = function(showCloseButton) {
        showCloseButton || canSwitch() ? canSwitch() ? showCloseButton || $.closeButton.hide() : $.switchButton.hide() : $.index.hide();
        canSwitch() && ($.switchButton.title = getNextGraphType());
        return;
    };
    __defers["$.__views.closeButton!click!doClose"] && $.__views.closeButton.addEventListener("click", doClose);
    __defers["$.__views.switchButton!click!doSwitchGraph"] && $.__views.switchButton.addEventListener("click", doSwitchGraph);
    __defers["$.__views.closeButton!click!doClose"] && $.__views.closeButton.addEventListener("click", doClose);
    __defers["$.__views.switchButton!click!doSwitchGraph"] && $.__views.switchButton.addEventListener("click", doSwitchGraph);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;