function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function onOpen() {
        require("Piwik/Tracker").trackWindow("Help", "help");
    }
    function onClose() {
        $.destroy();
        $.off();
    }
    function openFaq() {
        require("commands/openFaq").execute();
    }
    function openAboutPiwikMobile() {
        var about = Alloy.createController("about_piwik_mobile");
        about.open();
    }
    function emailUs() {
        require("commands/sendEmailFeedback").execute();
        require("Piwik/Tracker").trackEvent({
            title: "Email Us",
            url: "/help/email-us"
        });
    }
    function openForum() {
        var params = {
            title: L("General_Forums"),
            url: "http://forum.piwik.org/"
        };
        Alloy.createController("webview", params).open();
    }
    function openDocumentation() {
        var params = {
            title: L("General_Documentation"),
            url: "http://piwik.org/docs/"
        };
        Alloy.createController("webview", params).open();
    }
    function toggleReportChooserVisibility() {
        require("report/chooser").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Chooser",
            url: "/help/toggle/report-chooser"
        });
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.index = Ti.UI.createWindow({
        barImage: "navbar.png",
        backgroundColor: "#FFFFFF",
        barColor: "#CD1628",
        title: L("General_Help"),
        backButtonTitle: L("Mobile_NavigationBack"),
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    onClose ? $.__views.index.addEventListener("close", onClose) : __defers["$.__views.index!close!onClose"] = true;
    onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
    if (true && !Alloy.isTablet) {
        $.__views.__alloyId76 = Ti.UI.createButton({
            backgroundImage: "ic_action_menu.png",
            width: 32,
            height: 32,
            id: "__alloyId76"
        });
        toggleReportChooserVisibility ? $.__views.__alloyId76.addEventListener("click", toggleReportChooserVisibility) : __defers["$.__views.__alloyId76!click!toggleReportChooserVisibility"] = true;
        $.__views.index.leftNavButton = $.__views.__alloyId76;
    }
    $.__views.about = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        hasChild: true,
        title: L("Mobile_AboutPiwikMobile"),
        id: "about"
    });
    var __alloyId79 = [];
    __alloyId79.push($.__views.about);
    openAboutPiwikMobile ? $.__views.about.addEventListener("click", openAboutPiwikMobile) : __defers["$.__views.about!click!openAboutPiwikMobile"] = true;
    $.__views.faq = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        hasChild: true,
        title: L("General_Faq"),
        id: "faq"
    });
    __alloyId79.push($.__views.faq);
    openFaq ? $.__views.faq.addEventListener("click", openFaq) : __defers["$.__views.faq!click!openFaq"] = true;
    $.__views.documentation = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        hasChild: true,
        title: L("General_Documentation"),
        id: "documentation"
    });
    __alloyId79.push($.__views.documentation);
    openDocumentation ? $.__views.documentation.addEventListener("click", openDocumentation) : __defers["$.__views.documentation!click!openDocumentation"] = true;
    $.__views.forums = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        hasChild: true,
        title: L("General_Forums"),
        id: "forums"
    });
    __alloyId79.push($.__views.forums);
    openForum ? $.__views.forums.addEventListener("click", openForum) : __defers["$.__views.forums!click!openForum"] = true;
    $.__views.email = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        hasChild: true,
        title: L("Mobile_EmailUs"),
        id: "email"
    });
    __alloyId79.push($.__views.email);
    emailUs ? $.__views.email.addEventListener("click", emailUs) : __defers["$.__views.email!click!emailUs"] = true;
    $.__views.helpTable = Ti.UI.createTableView({
        data: __alloyId79,
        id: "helpTable"
    });
    $.__views.index.add($.__views.helpTable);
    exports.destroy = function() {};
    _.extend($, $.__views);
    exports.close = function() {
        require("layout").close($.index);
    };
    exports.open = function() {
        require("layout").open($.index);
    };
    __defers["$.__views.index!close!onClose"] && $.__views.index.addEventListener("close", onClose);
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.__alloyId76!click!toggleReportChooserVisibility"] && $.__views.__alloyId76.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.__alloyId78!click!toggleReportChooserVisibility"] && $.__views.__alloyId78.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.headerBar!homeIconItemSelected!toggleReportChooserVisibility"] && $.__views.headerBar.on("homeIconItemSelected", toggleReportChooserVisibility);
    __defers["$.__views.about!click!openAboutPiwikMobile"] && $.__views.about.addEventListener("click", openAboutPiwikMobile);
    __defers["$.__views.faq!click!openFaq"] && $.__views.faq.addEventListener("click", openFaq);
    __defers["$.__views.documentation!click!openDocumentation"] && $.__views.documentation.addEventListener("click", openDocumentation);
    __defers["$.__views.forums!click!openForum"] && $.__views.forums.addEventListener("click", openForum);
    __defers["$.__views.email!click!emailUs"] && $.__views.email.addEventListener("click", emailUs);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;