function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function displayRefreshMessage() {
        $.tableView && $.tableView.setContentInsets({
            top: 60
        });
        setStatusReloading();
    }
    function doRefresh() {
        if ($.reloading) return;
        displayRefreshMessage();
        $.trigger("refresh");
    }
    function currentTime() {
        var moment = require("moment/moment");
        return moment().format("LT");
    }
    function setStatusReloading() {
        $.reloading = true;
        $.pulling = false;
        var now = currentTime();
        $.lastUpdatedLabel.text = String.format(L("Mobile_LastUpdated"), now);
        $.statusLabel.text = L("Mobile_Reloading");
        $.arrow.hide();
        $.arrow.transform = Ti.UI.create2DMatrix();
        $.activityIndicator.show();
    }
    function setStatusReleaseToRefresh() {
        var transform = Ti.UI.create2DMatrix();
        transform = transform.rotate(-180);
        $.pulling = true;
        $.arrow.animate({
            transform: transform,
            duration: 180
        });
        $.statusLabel.text = L("Mobile_ReleaseToRefresh");
    }
    function setStatusPullDownToRefresh() {
        $.pulling = false;
        var transform = Ti.UI.create2DMatrix();
        $.arrow.animate({
            transform: transform,
            duration: 180
        });
        $.statusLabel.text = L("Mobile_PullDownToRefresh");
    }
    function onScrollTable(event) {
        var offset = event && event.contentOffset ? event.contentOffset.y : 0;
        -65 >= offset && !$.pulling && !$.reloading ? setStatusReleaseToRefresh() : $.pulling && !$.reloading && offset > -65 && 0 > offset && setStatusPullDownToRefresh();
    }
    function onDragEnd() {
        $.pulling && !$.reloading && doRefresh();
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    $.__views.pull_to_refresh = Ti.UI.createView({
        backgroundColor: "#E2E7ED",
        width: 320,
        height: 60,
        id: "pull_to_refresh"
    });
    $.__views.pull_to_refresh && $.addTopLevelView($.__views.pull_to_refresh);
    $.__views.arrow = Ti.UI.createView({
        backgroundImage: "pull_arrow.png",
        width: 23,
        height: 60,
        bottom: 10,
        left: 20,
        id: "arrow"
    });
    $.__views.pull_to_refresh.add($.__views.arrow);
    $.__views.statusLabel = Ti.UI.createLabel({
        color: "#576C89",
        shadowOffset: {
            x: 0,
            y: 1
        },
        text: L("Mobile_PullDownToRefresh"),
        width: 200,
        bottom: 30,
        height: "SIZE",
        textAlign: "center",
        font: {
            fontSize: 13,
            fontWeight: "bold"
        },
        shadowColor: "#fff",
        id: "statusLabel"
    });
    $.__views.pull_to_refresh.add($.__views.statusLabel);
    $.__views.lastUpdatedLabel = Ti.UI.createLabel({
        color: "#576C89",
        shadowOffset: {
            x: 0,
            y: 1
        },
        text: "",
        width: 200,
        bottom: 15,
        height: "SIZE",
        textAlign: "center",
        font: {
            fontSize: 12
        },
        shadowColor: "#fff",
        id: "lastUpdatedLabel"
    });
    $.__views.pull_to_refresh.add($.__views.lastUpdatedLabel);
    $.__views.activityIndicator = Ti.UI.createActivityIndicator({
        left: 20,
        bottom: 13,
        width: 30,
        height: 30,
        id: "activityIndicator"
    });
    $.__views.pull_to_refresh.add($.__views.activityIndicator);
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.reloading = false;
    $.pulling = false;
    $.tableView = null;
    exports.refresh = displayRefreshMessage;
    exports.init = function(tableView) {
        $.tableView = tableView;
        $.tableView.addEventListener("scroll", onScrollTable);
        $.tableView.addEventListener("dragEnd", onDragEnd);
    };
    exports.refreshDone = function() {
        $.reloading = false;
        $.tableView && $.tableView.setContentInsets({
            top: 0
        });
        $.statusLabel && ($.statusLabel.text = L("Mobile_PullDownToRefresh"));
        $.arrow && $.arrow.show();
        $.activityIndicator && $.activityIndicator.hide();
    };
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;