function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function registerEvents() {
        var session = require("session");
        session.on("websiteChanged", openRealTimeMapInWebview);
    }
    function unregisterEvents() {
        var session = require("session");
        session.off("websiteChanged", openRealTimeMapInWebview);
    }
    function trackWindowRequest() {
        require("Piwik/Tracker").trackWindow("Real-time Map", "real-time-map");
    }
    function onOpen() {
        trackWindowRequest();
    }
    function onClose() {
        unregisterEvents();
        $.destroy();
        $.off();
    }
    function openRealTimeMapInWebview() {
        var accountModel = require("session").getAccount();
        var siteModel = require("session").getWebsite();
        var url = accountModel.getBasePath();
        url += "index.php?module=Widgetize&action=iframe&widget=1&moduleToWidgetize=UserCountryMap&actionToWidgetize=realtimeMap&idSite=";
        url += siteModel.id;
        url += "&period=month&date=today&disableLink=1&widget=1";
        $.webview.url = url;
    }
    function toggleReportConfiguratorVisibility() {
        require("report/configurator").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Configurator",
            url: "/real-time-map/toggle/report-configurator"
        });
    }
    function toggleReportChooserVisibility() {
        require("report/chooser").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Chooser",
            url: "/real-time-map/toggle/report-chooser"
        });
    }
    function close() {
        require("layout").close($.index);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.index = Ti.UI.createWindow({
        barImage: "navbar.png",
        backgroundColor: "#FFFFFF",
        barColor: "#CD1628",
        title: L("UserCountryMap_RealTimeMap"),
        backButtonTitle: L("Mobile_NavigationBack"),
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    onClose ? $.__views.index.addEventListener("close", onClose) : __defers["$.__views.index!close!onClose"] = true;
    onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
    if (true && !Alloy.isTablet) {
        $.__views.__alloyId96 = Ti.UI.createButton({
            backgroundImage: "ic_action_menu.png",
            width: 32,
            height: 32,
            id: "__alloyId96"
        });
        toggleReportChooserVisibility ? $.__views.__alloyId96.addEventListener("click", toggleReportChooserVisibility) : __defers["$.__views.__alloyId96!click!toggleReportChooserVisibility"] = true;
        $.__views.index.leftNavButton = $.__views.__alloyId96;
    }
    if (true && !Alloy.isTablet) {
        $.__views.__alloyId102 = Ti.UI.createButton({
            backgroundImage: "ic_action_reportmenu.png",
            width: 32,
            height: 32,
            id: "__alloyId102"
        });
        toggleReportConfiguratorVisibility ? $.__views.__alloyId102.addEventListener("click", toggleReportConfiguratorVisibility) : __defers["$.__views.__alloyId102!click!toggleReportConfiguratorVisibility"] = true;
        $.__views.index.rightNavButton = $.__views.__alloyId102;
    }
    $.__views.webview = Ti.UI.createWebView({
        disableBounce: true,
        scalesPageToFit: false,
        enableZoomControls: false,
        id: "webview"
    });
    $.__views.index.add($.__views.webview);
    exports.destroy = function() {};
    _.extend($, $.__views);
    exports.open = function() {
        openRealTimeMapInWebview();
        registerEvents();
        require("layout").open($.index);
    };
    exports.close = close;
    __defers["$.__views.index!close!onClose"] && $.__views.index.addEventListener("close", onClose);
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.__alloyId96!click!toggleReportChooserVisibility"] && $.__views.__alloyId96.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.__alloyId98!click!toggleReportChooserVisibility"] && $.__views.__alloyId98.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.__alloyId100!click!toggleReportConfiguratorVisibility"] && $.__views.__alloyId100.addEventListener("click", toggleReportConfiguratorVisibility);
    __defers["$.__views.__alloyId102!click!toggleReportConfiguratorVisibility"] && $.__views.__alloyId102.addEventListener("click", toggleReportConfiguratorVisibility);
    __defers["$.__views.headerBar!homeIconItemSelected!toggleReportChooserVisibility"] && $.__views.headerBar.on("homeIconItemSelected", toggleReportChooserVisibility);
    __defers["$.__views.headerBar!actionItem1!toggleReportConfiguratorVisibility"] && $.__views.headerBar.on("actionItem1", toggleReportConfiguratorVisibility);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;