function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function updateAvailableReportsList() {
        if (!reportsCollection) return;
        var rows = [];
        var currentSection = null;
        var latestSection = null;
        rows.push(Alloy.createController("report_chooser_section", {
            title: L("General_Live")
        }).getView());
        rows.push(Alloy.createController("report_chooser_row", {
            title: L("UserCountryMap_RealTimeMap"),
            cid: "visitormap"
        }).getView());
        rows.push(Alloy.createController("report_chooser_row", {
            title: L("Live_VisitorsInRealTime"),
            cid: "live"
        }).getView());
        rows.push(Alloy.createController("report_chooser_row", {
            title: L("Live_VisitorLog"),
            cid: "visitorlog"
        }).getView());
        rows.push(Alloy.createController("report_chooser_section", {
            title: L("General_Reports")
        }).getView());
        cidToSelect || setCurrentlySelectedCid(getCidOfEntryReport(reportsCollection));
        reportsCollection.forEach(function(report) {
            currentSection = report.get("category");
            if ("MultiSites" == report.get("module") || "API" == report.get("module")) return;
            if (currentSection && currentSection !== latestSection) {
                rows.push(Alloy.createController("report_chooser_row", {
                    title: currentSection,
                    cid: report.cid
                }).getView());
                latestSection = currentSection;
            }
        });
        rows.push(Alloy.createController("report_chooser_section", {
            title: L("CoreAdminHome_MenuManage")
        }).getView());
        rows.push(Alloy.createController("report_chooser_row", {
            title: L("Mobile_Accounts"),
            cid: "accounts"
        }).getView());
        rows.push(Alloy.createController("report_chooser_row", {
            title: L("General_Settings"),
            cid: "settings"
        }).getView());
        rows.push(Alloy.createController("report_chooser_row", {
            title: L("General_Help"),
            cid: "help"
        }).getView());
        rows.push(Alloy.createController("report_chooser_row", {
            title: L("General_GiveUsYourFeedback"),
            cid: "feedback"
        }).getView());
        $.reportsTable.setData(rows);
        makeSureSelectedRowIsStillSelected();
        rows = null;
    }
    function setCurrentlySelectedCid(cidOfReport) {
        cidToSelect = cidOfReport;
    }
    function makeSureSelectedRowIsStillSelected() {
        if ($.reportsTable.selectRow && cidToSelect) {
            var index = 0;
            _.forEach($.reportsTable.data, function(section) {
                if (!section || !section.rows) return;
                _.forEach(section.rows, function(row) {
                    cidToSelect == row.cid && $.reportsTable.selectRow(index);
                    index++;
                });
            });
        }
        rows = null;
    }
    function getCidOfEntryReport(reportsCollection) {
        var entryReport = reportsCollection.getEntryReport();
        if (entryReport) return entryReport.cid;
    }
    function hideLeftSidebar() {
        require("layout").hideLeftSidebar();
    }
    function isAnAccountSelected() {
        return !!require("session").getAccount();
    }
    function isActionThatRequiresAnAccount(cid) {
        var cidsWhichDontRequireAnAccount = [ "settings", "help", "accounts", "feedback" ];
        return -1 === cidsWhichDontRequireAnAccount.indexOf(cid);
    }
    function doSelectReport(event) {
        if (!event || !event.rowData || !event.rowData.cid) return;
        var cid = event.rowData.cid;
        !isAnAccountSelected() && isActionThatRequiresAnAccount(cid) && (cid = "accounts");
        setCurrentlySelectedCid(cid);
        hideLeftSidebar();
        require("layout").closeRecordedWindows();
        if ("live" == cid) openLiveVisitors(); else if ("visitorlog" == cid) openVisitorLog(); else if ("visitormap" == cid) openVisitorMap(); else if ("settings" == cid) openSettings(); else if ("help" == cid) openHelp(); else if ("accounts" == cid) chooseAccount(); else if ("feedback" == cid) openGiveFeedback(); else {
            var report = reportsCollection.getByCid(cid);
            openCompositeReport(report);
        }
    }
    function openHelp() {
        var help = Alloy.createController("help");
        help.open();
    }
    function openSettings() {
        var settings = Alloy.createController("settings");
        settings.open();
    }
    function chooseAccount() {
        var accounts = Alloy.createController("accounts");
        accounts.on("accountChosen", onAccountChosen);
        accounts.open();
    }
    function onAccountChosen(account) {
        require("account").selectWebsite(account, function(siteModel, accountModel) {
            require("session").setWebsite(siteModel, accountModel);
            openEntryReport();
        });
        this.off("accountChosen");
    }
    function openCompositeReport(chosenReportModel) {
        var reportCategory = chosenReportModel.get("category");
        var statistics = Alloy.createController("report_composite", {
            reportCategory: reportCategory
        });
        statistics.open();
    }
    function openLiveVisitors() {
        var live = Alloy.createController("live_visitors");
        live.open();
    }
    function openVisitorLog() {
        var log = Alloy.createController("visitor_log");
        log.open();
    }
    function openVisitorMap() {
        var realtimemap = Alloy.createController("realtime_map");
        realtimemap.open();
    }
    function openGiveFeedback() {
        var feedback = Alloy.createController("give_feedback");
        feedback.open();
    }
    function refresh() {
        var accountModel = require("session").getAccount();
        var siteModel = require("session").getWebsite();
        if (!siteModel || !accountModel) {
            console.log("no website/account selected", "report_chooser");
            return;
        }
        reportsCollection.fetchAllReports(accountModel, siteModel);
    }
    function openEntryReport() {
        require("layout").closeRecordedWindows();
        var compositeReport = Alloy.createController("report_composite");
        compositeReport.open();
        setCurrentlySelectedCid(getCidOfEntryReport(reportsCollection));
        makeSureSelectedRowIsStillSelected();
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    Alloy.Collections.instance("piwikReports");
    $.__views.reportsTable = Ti.UI.createTableView({
        separatorColor: "#2D2D2D",
        id: "reportsTable"
    });
    if (Alloy.isTablet) {
        $.__views.__alloyId106 = Ti.UI.createView({
            layout: "vertical",
            height: Ti.UI.SIZE,
            width: Ti.UI.FILL,
            backgroundColor: "#222222",
            id: "__alloyId106"
        });
        $.__views.__alloyId107 = Ti.UI.createView({
            top: 12,
            bottom: 0,
            left: 8,
            right: 8,
            height: Ti.UI.SIZE,
            id: "__alloyId107"
        });
        $.__views.__alloyId106.add($.__views.__alloyId107);
        $.__views.__alloyId108 = Alloy.createController("website_picker", {
            id: "__alloyId108",
            __parentSymbol: $.__views.__alloyId107
        });
        $.__views.__alloyId108.setParent($.__views.__alloyId107);
        hideLeftSidebar ? $.__views.__alloyId108.on("selected", hideLeftSidebar) : __defers["$.__views.__alloyId108!selected!hideLeftSidebar"] = true;
        $.__views.__alloyId109 = Ti.UI.createView({
            top: 10,
            bottom: 12,
            left: 8,
            right: 8,
            height: Ti.UI.SIZE,
            id: "__alloyId109"
        });
        $.__views.__alloyId106.add($.__views.__alloyId109);
        $.__views.__alloyId110 = Alloy.createController("date_picker", {
            id: "__alloyId110",
            __parentSymbol: $.__views.__alloyId109
        });
        $.__views.__alloyId110.setParent($.__views.__alloyId109);
        hideLeftSidebar ? $.__views.__alloyId110.on("selected", hideLeftSidebar) : __defers["$.__views.__alloyId110!selected!hideLeftSidebar"] = true;
        $.__views.reportsTable.headerView = $.__views.__alloyId106;
    }
    $.__views.reportsTable && $.addTopLevelView($.__views.reportsTable);
    doSelectReport ? $.__views.reportsTable.addEventListener("click", doSelectReport) : __defers["$.__views.reportsTable!click!doSelectReport"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    var reportsCollection = Alloy.Collections.piwikReports;
    reportsCollection.on("reset", updateAvailableReportsList);
    var cidToSelect = "";
    exports.open = function() {
        require("layout").setLeftSidebar($.reportsTable);
        require("layout").startRecordingWindows();
        require("session").on("accountChanged", refresh);
        Alloy.createCollection("AppSettings").settings().on("change:language", refresh);
        openEntryReport();
        refresh();
    };
    __defers["$.__views.__alloyId108!selected!hideLeftSidebar"] && $.__views.__alloyId108.on("selected", hideLeftSidebar);
    __defers["$.__views.__alloyId110!selected!hideLeftSidebar"] && $.__views.__alloyId110.on("selected", hideLeftSidebar);
    __defers["$.__views.reportsTable!click!doSelectReport"] && $.__views.reportsTable.addEventListener("click", doSelectReport);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;