function Controller() {
    function renderListOfReports() {
        renderListOfReports.opts || {};
        var models = filterReports(__alloyId127);
        var len = models.length;
        var children = $.__views.__alloyId121.children;
        for (var d = children.length - 1; d >= 0; d--) $.__views.__alloyId121.remove(children[d]);
        for (var i = 0; len > i; i++) {
            var __alloyId122 = models[i];
            __alloyId122.__transform = {};
            var __alloyId124 = Alloy.createController("report_overview", {
                title: "undefined" != typeof __alloyId122.__transform["name"] ? __alloyId122.__transform["name"] : __alloyId122.get("name"),
                $model: __alloyId122,
                __parentSymbol: $.__views.__alloyId121
            });
            __alloyId124.setParent($.__views.__alloyId121);
            var __alloyId126 = Ti.UI.createView({
                height: 10
            });
            $.__views.__alloyId121.add(__alloyId126);
        }
    }
    function registerEvents() {
        Alloy.Collections.piwikReports.on("reset", hideLoadingIndicator);
        var session = require("session");
        session.on("websiteChanged", onWebsiteChanged);
        session.on("reportDateChanged", onDateChanged);
        $.content.addEventListener("scroll", notifyModelsAboutNewScrollPosition);
    }
    function unregisterEvents() {
        Alloy.Collections.piwikReports.off("reset", hideLoadingIndicator);
        var session = require("session");
        session.off("websiteChanged", onWebsiteChanged);
        session.off("reportDateChanged", onDateChanged);
        $.content.removeEventListener("scroll", notifyModelsAboutNewScrollPosition);
    }
    function trackWindowRequest() {
        var category = reportCategory ? reportCategory : "";
        require("Piwik/Tracker").setCustomVariable(1, "reportCategory", category, "page");
        require("Piwik/Tracker").trackWindow("Composite Report", "report/composite");
    }
    function onOpen() {
        trackWindowRequest();
    }
    function onClose() {
        unregisterEvents();
        $.destroy();
        $.off();
    }
    function hideLoadingIndicator() {
        $.loadingIndicator.hide();
    }
    function showLoadingIndicator() {
        $.loadingIndicator.show();
    }
    function toggleReportConfiguratorVisibility() {
        require("report/configurator").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Configurator",
            url: "/report/composite/toggle/report-configurator"
        });
    }
    function toggleReportChooserVisibility() {
        require("report/chooser").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Chooser",
            url: "/report/composite/toggle/report-chooser"
        });
    }
    function accountDidNotChange() {
        return require("session").getAccount().isSameAccount(accountModel);
    }
    function onWebsiteChanged() {
        accountDidNotChange() && renderListOfReports();
        require("Piwik/Tracker").trackEvent({
            title: "Website Changed",
            url: "/report/composite/change/website"
        });
    }
    function onDateChanged() {
        accountDidNotChange() && renderListOfReports();
        require("Piwik/Tracker").trackEvent({
            title: "Date Changed",
            url: "/report/composite/change/date"
        });
    }
    function updateWindowTitle(title) {
        $.index.title = title || "";
    }
    function filterReports(collection) {
        if (!reportCategory) {
            var entryReport = collection.getEntryReport();
            if (!entryReport) return collection;
            reportCategory = entryReport.get("category");
        }
        updateWindowTitle(reportCategory);
        return collection.where({
            category: reportCategory
        });
    }
    function notifyModelsAboutNewScrollPosition(event) {
        _.forEach(filterReports(reportsCollection), function(model) {
            model.trigger("scrollPosition", {
                y: event.y
            });
        });
    }
    function isDataAlreadyFetched() {
        return !!reportsCollection.length;
    }
    function open() {
        registerEvents();
        require("layout").open($.index);
        if (isDataAlreadyFetched()) {
            hideLoadingIndicator();
            renderListOfReports();
        } else showLoadingIndicator();
    }
    function close() {
        require("layout").close($.index);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    Alloy.Collections.instance("piwikReports");
    $.__views.index = Ti.UI.createWindow({
        barImage: "navbar.png",
        backgroundColor: "#e5e5e5",
        barColor: "#CD1628",
        title: "",
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    onClose ? $.__views.index.addEventListener("close", onClose) : __defers["$.__views.index!close!onClose"] = true;
    onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
    if (true && !Alloy.isTablet) {
        $.__views.__alloyId114 = Ti.UI.createButton({
            backgroundImage: "ic_action_menu.png",
            width: 32,
            height: 32,
            id: "__alloyId114"
        });
        toggleReportChooserVisibility ? $.__views.__alloyId114.addEventListener("click", toggleReportChooserVisibility) : __defers["$.__views.__alloyId114!click!toggleReportChooserVisibility"] = true;
        $.__views.index.leftNavButton = $.__views.__alloyId114;
    }
    if (true && !Alloy.isTablet) {
        $.__views.__alloyId120 = Ti.UI.createButton({
            backgroundImage: "ic_action_reportmenu.png",
            width: 32,
            height: 32,
            id: "__alloyId120"
        });
        toggleReportConfiguratorVisibility ? $.__views.__alloyId120.addEventListener("click", toggleReportConfiguratorVisibility) : __defers["$.__views.__alloyId120!click!toggleReportConfiguratorVisibility"] = true;
        $.__views.index.rightNavButton = $.__views.__alloyId120;
    }
    $.__views.loadingIndicator = Alloy.createController("loading_indicator", {
        rounded: true,
        id: "loadingIndicator",
        __parentSymbol: $.__views.index
    });
    $.__views.loadingIndicator.setParent($.__views.index);
    $.__views.content = Ti.UI.createScrollView({
        layout: "vertical",
        backgroundColor: "#e5e5e5",
        contentHeight: "auto",
        showVerticalScrollIndicator: true,
        id: "content"
    });
    $.__views.index.add($.__views.content);
    $.__views.__alloyId121 = Ti.UI.createView({
        layout: "vertical",
        height: Ti.UI.SIZE,
        left: 10,
        right: 10,
        top: 10,
        dataFunction: "renderListOfReports",
        id: "__alloyId121"
    });
    $.__views.content.add($.__views.__alloyId121);
    var __alloyId127 = Alloy.Collections["piwikReports"] || piwikReports;
    __alloyId127.on("fetch destroy change add remove reset", renderListOfReports);
    $.__views.__alloyId128 = Ti.UI.createImageView({
        top: 2,
        bottom: 25,
        width: 55,
        height: 19,
        image: "piwik_logo_dark_footer.png",
        id: "__alloyId128"
    });
    $.__views.content.add($.__views.__alloyId128);
    exports.destroy = function() {
        __alloyId127.off("fetch destroy change add remove reset", renderListOfReports);
    };
    _.extend($, $.__views);
    var args = arguments[0] || {};
    var reportCategory = args.reportCategory || null;
    var reportsCollection = Alloy.Collections.piwikReports;
    require("session").getReportDate();
    var accountModel = require("session").getAccount();
    exports.close = close;
    exports.open = open;
    __defers["$.__views.index!close!onClose"] && $.__views.index.addEventListener("close", onClose);
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.__alloyId114!click!toggleReportChooserVisibility"] && $.__views.__alloyId114.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.__alloyId116!click!toggleReportChooserVisibility"] && $.__views.__alloyId116.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.__alloyId118!click!toggleReportConfiguratorVisibility"] && $.__views.__alloyId118.addEventListener("click", toggleReportConfiguratorVisibility);
    __defers["$.__views.__alloyId120!click!toggleReportConfiguratorVisibility"] && $.__views.__alloyId120.addEventListener("click", toggleReportConfiguratorVisibility);
    __defers["$.__views.headerBar!homeIconItemSelected!toggleReportChooserVisibility"] && $.__views.headerBar.on("homeIconItemSelected", toggleReportChooserVisibility);
    __defers["$.__views.headerBar!actionItem1!toggleReportConfiguratorVisibility"] && $.__views.headerBar.on("actionItem1", toggleReportConfiguratorVisibility);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;