function Controller() {
    function openReport() {
        var report = Alloy.createController("report_without_dimension", {
            report: $model
        });
        report.open();
    }
    function renderGraph() {
        var accountModel = require("session").getAccount();
        $.piwikProcessedReport.first() && $.graphCtrl.update($.piwikProcessedReport, accountModel);
    }
    function fetchProcessedReport() {
        var accountModel = require("session").getAccount();
        var siteModel = require("session").getWebsite();
        if (!accountModel || !siteModel) {
            console.log("account or site not found, cannot refresh report overview without dimension");
            return;
        }
        var module = $model.get("module");
        var action = $model.get("action");
        var metric = $model.getSortOrder();
        $.piwikProcessedReport.fetchProcessedReports(metric, {
            account: accountModel,
            params: {
                period: reportDate.getPeriodQueryString(),
                date: reportDate.getDateQueryString(),
                idSite: siteModel.id,
                flat: flatten,
                filter_limit: 1,
                apiModule: module,
                apiAction: action
            }
        });
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    var $model = arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.piwikProcessedReport = Alloy.createCollection("piwikProcessedReport");
    $.__views.index = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        borderRadius: 5,
        borderColor: "#d3d3d3",
        borderWidth: 1,
        backgroundColor: "white",
        top: 0,
        layout: "vertical",
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    $.__views.__alloyId163 = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        top: 18,
        bottom: 18,
        left: 10,
        id: "__alloyId163"
    });
    $.__views.index.add($.__views.__alloyId163);
    openReport ? $.__views.__alloyId163.addEventListener("click", openReport) : __defers["$.__views.__alloyId163!click!openReport"] = true;
    $.__views.headline = Ti.UI.createLabel({
        color: "#191919",
        font: {
            fontWeight: "bold"
        },
        left: 0,
        width: Ti.UI.SIZE,
        id: "headline"
    });
    $.__views.__alloyId163.add($.__views.headline);
    $.__views.__alloyId164 = Ti.UI.createView({
        height: 1,
        width: Ti.UI.FILL,
        backgroundColor: "#dcdcdc",
        bottom: 0,
        id: "__alloyId164"
    });
    $.__views.index.add($.__views.__alloyId164);
    $.__views.content = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        backgroundColor: "#efefef",
        layout: "vertical",
        id: "content"
    });
    $.__views.index.add($.__views.content);
    $.__views.graphCtrl = Alloy.createController("graph", {
        id: "graphCtrl",
        __parentSymbol: $.__views.content
    });
    $.__views.graphCtrl.setParent($.__views.content);
    $.__views.__alloyId165 = Ti.UI.createView({
        height: 1,
        width: Ti.UI.FILL,
        backgroundColor: "#dcdcdc",
        bottom: 0,
        id: "__alloyId165"
    });
    $.__views.index.add($.__views.__alloyId165);
    $.__views.__alloyId166 = Ti.UI.createView({
        height: 35,
        width: Ti.UI.FILL,
        id: "__alloyId166"
    });
    $.__views.index.add($.__views.__alloyId166);
    openReport ? $.__views.__alloyId166.addEventListener("click", openReport) : __defers["$.__views.__alloyId166!click!openReport"] = true;
    $.__views.__alloyId167 = Ti.UI.createLabel({
        color: "#333333",
        left: 10,
        width: Ti.UI.SIZE,
        text: "More",
        id: "__alloyId167"
    });
    $.__views.__alloyId166.add($.__views.__alloyId167);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    var flatten = args.flatten || 0;
    var reportDate = require("session").getReportDate();
    var $model = args ? args["$model"] : null;
    $.headline.text = String.format("%s (%s)", "" + $model.getReportName(), "" + $model.getMetricName());
    $.piwikProcessedReport.on("reset", renderGraph);
    fetchProcessedReport();
    __defers["$.__views.__alloyId163!click!openReport"] && $.__views.__alloyId163.addEventListener("click", openReport);
    __defers["$.__views.__alloyId166!click!openReport"] && $.__views.__alloyId166.addEventListener("click", openReport);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;