function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function trackWindowRequest() {
        var uniqueId = reportModule + "_" + reportAction;
        require("Piwik/Tracker").setCustomVariable(1, "reportModule", reportModule, "page");
        require("Piwik/Tracker").setCustomVariable(2, "reportAction", reportAction, "page");
        require("Piwik/Tracker").setCustomVariable(3, "reportUniqueId", uniqueId, "page");
        require("Piwik/Tracker").setCustomVariable(4, "reportMetric", currentMetric, "page");
        require("Piwik/Tracker").trackWindow("Report Subtable", "report/subtable");
    }
    function onOpen() {
        trackWindowRequest();
    }
    function onClose() {
        $.destroy();
    }
    function onMetricChosen(chosenMetric) {
        require("Piwik/Tracker").trackEvent({
            title: "Metric Changed",
            url: "/report/subtable/change/metric/" + chosenMetric
        });
        currentMetric = chosenMetric;
        $.doRefresh();
    }
    function toggleReportConfiguratorVisibility() {
        require("report/configurator").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Configurator",
            url: "/report/composite/toggle/report-configurator"
        });
    }
    function updateWindowTitle(title) {
        $.index.title = title || "";
    }
    function open() {
        $.doRefresh();
        require("layout").open($.index);
    }
    function close() {
        require("layout").close($.index);
    }
    require("alloy/controllers/report_with_dimension_base").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.piwikProcessedReport = Alloy.createCollection("piwikProcessedReport");
    $.__views.index = Ti.UI.createWindow({
        barImage: "navbar.png",
        backgroundColor: "white",
        barColor: "#CD1628",
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        zIndex: 3,
        backButtonTitle: L("Mobile_NavigationBack"),
        title: "",
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    onClose ? $.__views.index.addEventListener("close", onClose) : __defers["$.__views.index!close!onClose"] = true;
    onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
    $.__views.loadingindicator = Alloy.createController("loading_indicator", {
        rounded: true,
        id: "loadingindicator",
        __parentSymbol: $.__views.index
    });
    $.__views.loadingindicator.setParent($.__views.index);
    $.__views.content = Ti.UI.createView({
        layout: "vertical",
        id: "content"
    });
    $.__views.index.add($.__views.content);
    $.__views.__alloyId173 = Ti.UI.createTableViewRow({
        id: "__alloyId173"
    });
    var __alloyId174 = [];
    __alloyId174.push($.__views.__alloyId173);
    $.__views.reportGraphCtrl = Alloy.createController("graph", {
        id: "reportGraphCtrl",
        __parentSymbol: $.__views.__alloyId173
    });
    $.__views.reportGraphCtrl.setParent($.__views.__alloyId173);
    $.__views.__alloyId175 = Ti.UI.createTableViewRow({
        id: "__alloyId175"
    });
    __alloyId174.push($.__views.__alloyId175);
    $.__views.reportInfoCtrl = Alloy.createController("report_metadata", {
        id: "reportInfoCtrl",
        __parentSymbol: $.__views.__alloyId175
    });
    $.__views.reportInfoCtrl.setParent($.__views.__alloyId175);
    onMetricChosen ? $.__views.reportInfoCtrl.on("metricChosen", onMetricChosen) : __defers["$.__views.reportInfoCtrl!metricChosen!onMetricChosen"] = true;
    $.__views.reportTable = Ti.UI.createTableView({
        top: 0,
        separatorColor: "#e8e8e8",
        data: __alloyId174,
        id: "reportTable"
    });
    $.__views.content.add($.__views.reportTable);
    $.__views.__alloyId171 = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        id: "__alloyId171"
    });
    $.__views.__alloyId172 = Ti.UI.createImageView({
        top: 12,
        bottom: 25,
        width: 55,
        height: 19,
        image: "piwik_logo_light_footer.png",
        id: "__alloyId172"
    });
    $.__views.__alloyId171.add($.__views.__alloyId172);
    $.__views.reportTable.footerView = $.__views.__alloyId171;
    exports.destroy = function() {};
    _.extend($, $.__views);
    exports.baseController = "report_with_dimension_base";
    var args = arguments[0] || {};
    var reportAction = args.apiAction || "";
    var reportModule = args.apiModule || "";
    var subtableId = args.subtableId || "";
    var currentMetric = args.metric;
    var reportDate = require("session").getReportDate();
    updateWindowTitle(args.reportTitle);
    $.index.backButtonTitle = args.backButtonTitle;
    $.initLoadingMessage();
    exports.doRefresh = function() {
        $.showLoadingMessage();
        var accountModel = require("session").getAccount();
        var siteModel = require("session").getWebsite();
        if (!siteModel || !accountModel) {
            console.log("account or site not found, cannot refresh report subtable");
            return;
        }
        $.piwikProcessedReport.fetchProcessedReports(currentMetric, {
            account: accountModel,
            params: {
                period: reportDate.getPeriodQueryString(),
                date: reportDate.getDateQueryString(),
                idSite: siteModel.id,
                idSubtable: subtableId,
                filter_limit: $.showAllEntries ? -1 : $.rowsFilterLimit,
                apiModule: reportModule,
                apiAction: reportAction
            },
            success: $.renderProcessedReport
        });
    };
    exports.open = open;
    exports.close = close;
    __defers["$.__views.index!close!onClose"] && $.__views.index.addEventListener("close", onClose);
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.headerBar!back!close"] && $.__views.headerBar.on("back", close);
    __defers["$.__views.headerBar!actionItem1!toggleReportConfiguratorVisibility"] && $.__views.headerBar.on("actionItem1", toggleReportConfiguratorVisibility);
    __defers["$.__views.pullToRefresh!refresh!exports.doRefresh"] && $.__views.pullToRefresh.on("refresh", exports.doRefresh);
    __defers["$.__views.reportInfoCtrl!metricChosen!onMetricChosen"] && $.__views.reportInfoCtrl.on("metricChosen", onMetricChosen);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;