function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function registerEvents() {
        var session = require("session");
        session.on("websiteChanged", onWebsiteChanged);
        session.on("reportDateChanged", onDateChanged);
    }
    function unregisterEvents() {
        var session = require("session");
        session.off("websiteChanged", onWebsiteChanged);
        session.off("reportDateChanged", onDateChanged);
    }
    function trackWindowRequest() {
        var module = reportModel.get("module");
        var action = reportModel.get("action");
        var uniqueId = reportModel.get("uniqueId");
        require("Piwik/Tracker").setCustomVariable(1, "reportModule", module, "page");
        require("Piwik/Tracker").setCustomVariable(2, "reportAction", action, "page");
        require("Piwik/Tracker").setCustomVariable(3, "reportUniqueId", uniqueId, "page");
        require("Piwik/Tracker").trackWindow("Report With Dimension", "report/with-dimension");
    }
    function onOpen() {
        trackWindowRequest();
    }
    function onClose() {
        unregisterEvents();
        $.destroy();
    }
    function onWebsiteChanged() {
        require("Piwik/Tracker").trackEvent({
            title: "Website Changed",
            url: "/report/with-dimension/change/website"
        });
        $.doRefresh();
    }
    function onDateChanged(changedReportDate) {
        require("Piwik/Tracker").trackEvent({
            title: "Date Changed",
            url: "/report/with-dimension/change/date"
        });
        reportDate = changedReportDate;
        $.doRefresh();
    }
    function onMetricChosen(chosenMetric) {
        require("Piwik/Tracker").trackEvent({
            title: "Metric Changed",
            url: "/report/with-dimension/change/metric/" + chosenMetric
        });
        currentMetric = chosenMetric;
        $.doRefresh();
    }
    function toggleReportConfiguratorVisibility() {
        require("report/configurator").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Configurator",
            url: "/report/with-dimension/toggle/report-configurator"
        });
    }
    function updateWindowTitle(title) {
        $.index.title = title || "";
    }
    function open() {
        registerEvents();
        $.doRefresh();
        require("layout").open($.index);
    }
    function close() {
        require("layout").close($.index);
    }
    require("alloy/controllers/report_with_dimension_base").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.piwikProcessedReport = Alloy.createCollection("piwikProcessedReport");
    $.__views.index = Ti.UI.createWindow({
        barImage: "navbar.png",
        backgroundColor: "white",
        barColor: "#CD1628",
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        zIndex: 3,
        backButtonTitle: L("Mobile_NavigationBack"),
        title: "",
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    onClose ? $.__views.index.addEventListener("close", onClose) : __defers["$.__views.index!close!onClose"] = true;
    onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
    if (true && !Alloy.isTablet) {
        $.__views.__alloyId179 = Ti.UI.createButton({
            backgroundImage: "ic_action_reportmenu.png",
            width: 32,
            height: 32,
            id: "__alloyId179"
        });
        toggleReportConfiguratorVisibility ? $.__views.__alloyId179.addEventListener("click", toggleReportConfiguratorVisibility) : __defers["$.__views.__alloyId179!click!toggleReportConfiguratorVisibility"] = true;
        $.__views.index.rightNavButton = $.__views.__alloyId179;
    }
    $.__views.loadingindicator = Alloy.createController("loading_indicator", {
        rounded: true,
        id: "loadingindicator",
        __parentSymbol: $.__views.index
    });
    $.__views.loadingindicator.setParent($.__views.index);
    $.__views.content = Ti.UI.createView({
        layout: "vertical",
        id: "content"
    });
    $.__views.index.add($.__views.content);
    $.__views.__alloyId184 = Ti.UI.createTableViewRow({
        id: "__alloyId184"
    });
    var __alloyId185 = [];
    __alloyId185.push($.__views.__alloyId184);
    $.__views.reportGraphCtrl = Alloy.createController("graph", {
        id: "reportGraphCtrl",
        __parentSymbol: $.__views.__alloyId184
    });
    $.__views.reportGraphCtrl.setParent($.__views.__alloyId184);
    $.__views.__alloyId186 = Ti.UI.createTableViewRow({
        id: "__alloyId186"
    });
    __alloyId185.push($.__views.__alloyId186);
    $.__views.reportInfoCtrl = Alloy.createController("report_metadata", {
        id: "reportInfoCtrl",
        __parentSymbol: $.__views.__alloyId186
    });
    $.__views.reportInfoCtrl.setParent($.__views.__alloyId186);
    onMetricChosen ? $.__views.reportInfoCtrl.on("metricChosen", onMetricChosen) : __defers["$.__views.reportInfoCtrl!metricChosen!onMetricChosen"] = true;
    $.__views.reportTable = Ti.UI.createTableView({
        top: 0,
        separatorColor: "#e8e8e8",
        data: __alloyId185,
        id: "reportTable"
    });
    $.__views.content.add($.__views.reportTable);
    $.__views.__alloyId182 = Ti.UI.createView({
        height: Ti.UI.SIZE,
        width: Ti.UI.FILL,
        id: "__alloyId182"
    });
    $.__views.__alloyId183 = Ti.UI.createImageView({
        top: 12,
        bottom: 25,
        width: 55,
        height: 19,
        image: "piwik_logo_light_footer.png",
        id: "__alloyId183"
    });
    $.__views.__alloyId182.add($.__views.__alloyId183);
    $.__views.reportTable.footerView = $.__views.__alloyId182;
    exports.destroy = function() {};
    _.extend($, $.__views);
    exports.baseController = "report_with_dimension_base";
    var args = arguments[0] || {};
    var currentMetric = null;
    var reportModel = args.report || false;
    args.reportList || {};
    var reportDate = require("session").getReportDate();
    updateWindowTitle(reportModel.getReportName());
    $.initLoadingMessage();
    exports.doRefresh = function() {
        $.showLoadingMessage();
        var accountModel = require("session").getAccount();
        var siteModel = require("session").getWebsite();
        if (!siteModel || !accountModel) {
            console.log("account or site not found, cannot refresh report with dimension");
            return;
        }
        var module = reportModel.get("module");
        var action = reportModel.get("action");
        var metric = reportModel.getSortOrder(currentMetric);
        $.piwikProcessedReport.fetchProcessedReports(metric, {
            account: accountModel,
            params: {
                period: reportDate.getPeriodQueryString(),
                date: reportDate.getDateQueryString(),
                idSite: siteModel.id,
                filter_limit: $.showAllEntries ? -1 : $.rowsFilterLimit,
                apiModule: module,
                apiAction: action
            },
            success: $.renderProcessedReport
        });
    };
    exports.open = open;
    exports.close = close;
    __defers["$.__views.index!close!onClose"] && $.__views.index.addEventListener("close", onClose);
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.__alloyId177!click!toggleReportConfiguratorVisibility"] && $.__views.__alloyId177.addEventListener("click", toggleReportConfiguratorVisibility);
    __defers["$.__views.__alloyId179!click!toggleReportConfiguratorVisibility"] && $.__views.__alloyId179.addEventListener("click", toggleReportConfiguratorVisibility);
    __defers["$.__views.headerBar!back!close"] && $.__views.headerBar.on("back", close);
    __defers["$.__views.headerBar!actionItem1!toggleReportConfiguratorVisibility"] && $.__views.headerBar.on("actionItem1", toggleReportConfiguratorVisibility);
    __defers["$.__views.pullToRefresh!refresh!exports.doRefresh"] && $.__views.pullToRefresh.on("refresh", exports.doRefresh);
    __defers["$.__views.reportInfoCtrl!metricChosen!onMetricChosen"] && $.__views.reportInfoCtrl.on("metricChosen", onMetricChosen);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;