function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function showReportContent() {
        $.loadingindicator.hide();
    }
    function onTogglePaginator() {
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Paginator",
            url: "/report/with-dimension/toggle/paginator"
        });
        $.showAllEntries = !$.showAllEntries;
        shouldScrollToPositionOfPaginator = $.showAllEntries;
        $.doRefresh();
    }
    function showReportHasNoData() {
        var row = Ti.UI.createTableViewRow({
            height: Ti.UI.SIZE,
            color: "#7e7e7e",
            title: L("CoreHome_ThereIsNoDataForThisReport")
        });
        $.reportTable.setData([ row ]);
    }
    function hasReportData(processedReportCollection) {
        return processedReportCollection && processedReportCollection.length;
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.rowsFilterLimit = Alloy.CFG.piwik.filterLimit;
    $.showAllEntries = false;
    var shouldScrollToPositionOfPaginator = false;
    exports.initLoadingMessage = function() {};
    exports.showLoadingMessage = function() {
        $.loadingindicator.show();
    };
    exports.renderProcessedReport = function(processedReportCollection) {
        showReportContent();
        $.reportTable.setData([]);
        if (!hasReportData(processedReportCollection)) {
            showReportHasNoData();
            return;
        }
        $.reportInfoCtrl && $.reportInfoCtrl.update(processedReportCollection);
        var accountModel = require("session").getAccount();
        $.reportGraphCtrl.update(processedReportCollection, accountModel);
        var rows = [];
        var settings = Alloy.createCollection("AppSettings").settings();
        if (settings.areGraphsEnabled()) {
            var row = Ti.UI.createTableViewRow({
                height: Ti.UI.SIZE
            });
            row.add($.reportGraphCtrl.getView());
            rows.push(row);
        }
        var row = Ti.UI.createTableViewRow({
            height: Ti.UI.SIZE
        });
        row.add($.reportInfoCtrl.getView());
        rows.push(row);
        processedReportCollection.forEach(function(processedReport) {
            if (!processedReport) return;
            var hasSubtable = processedReportCollection.hasSubtable() && processedReport.getSubtableId();
            var reportRow = Alloy.createController("report_row", processedReport);
            var row = Ti.UI.createTableViewRow({
                height: Ti.UI.SIZE,
                subtableId: processedReport.getSubtableId(),
                subtableAction: processedReportCollection.getActionToLoadSubTables(),
                subtableModule: processedReportCollection.getModule(),
                currentReportName: processedReportCollection.getReportName(),
                currentMetric: processedReport.getSortOrder(),
                reportTitle: processedReport.getTitle(),
                hasChild: Boolean(hasSubtable)
            });
            hasSubtable && row.addEventListener("click", function() {
                var params = {
                    backButtonTitle: this.currentReportName || L("Mobile_NavigationBack"),
                    apiModule: this.subtableModule,
                    apiAction: this.subtableAction,
                    subtableId: this.subtableId,
                    metric: this.currentMetric,
                    reportTitle: this.reportTitle
                };
                var subtableReport = Alloy.createController("report_subtable", params);
                subtableReport.open();
            });
            row.add(reportRow.getView());
            rows.push(row);
            row = null;
        });
        if ($.rowsFilterLimit <= processedReportCollection.length) {
            var row = Ti.UI.createTableViewRow({
                color: "#336699",
                title: $.showAllEntries ? L("Mobile_ShowLess") : L("Mobile_ShowAll")
            });
            row.left = 10;
            row.addEventListener("click", onTogglePaginator);
            rows.push(row);
        }
        $.reportTable.setData(rows);
        row = null;
        rows = null;
        if (shouldScrollToPositionOfPaginator) {
            $.reportTable.scrollToIndex($.rowsFilterLimit);
            shouldScrollToPositionOfPaginator = false;
        }
    };
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;