function Controller() {
    function L(key) {
        return require("L")(key);
    }
    function onOpen() {
        require("Piwik/Tracker").trackWindow("Settings", "settings");
    }
    function onClose() {
        if (supportsListView()) {
            var settings = Alloy.createCollection("AppSettings").settings();
            settings.off("change", updateAllDisplayedSettingsValues);
        }
        $.destroy();
        $.off();
    }
    function onItemClick(event) {
        var section = $.settingsTable.sections[event.sectionIndex];
        var item = section.getItemAt(event.itemIndex);
        var callback = item.properties.callback;
        callback && callbacks[callback] && callbacks[callback]();
    }
    function supportsListView() {
        return false;
    }
    function changeLanguage() {
        require("settings/changeLanguage").open();
        require("Piwik/Tracker").trackEvent({
            title: "Settings - Change Language",
            url: "/settings/change/language"
        });
    }
    function toggleTrackingEnabled() {
        require("settings/trackingEnabled").toggle();
        require("Piwik/Tracker").trackEvent({
            title: "Settings - Toggle Tracking Enabled",
            url: "/settings/toggle/tracking-enabled"
        });
    }
    function toggleGraphsEnabled() {
        require("settings/graphsEnabled").toggle();
        require("Piwik/Tracker").trackEvent({
            title: "Settings - Toggle Graphs Enabled",
            url: "/settings/toggle/graphs-enabled"
        });
    }
    function changeHttpTimeout() {
        require("settings/changeHttpTimeout").open();
        require("Piwik/Tracker").trackEvent({
            title: "Settings - Change HTTP Timeout",
            url: "/settings/change/http-timeout"
        });
    }
    function toggleReportChooserVisibility() {
        require("report/chooser").toggleVisibility();
        require("Piwik/Tracker").trackEvent({
            title: "Toggle Report Chooser",
            url: "/settings/toggle/report-chooser"
        });
    }
    function close() {
        callbacks = null;
        require("layout").close($.index);
    }
    function updateDisplayedLanguageValue() {
        var languageName = require("settings/changeLanguage").getCurrentLanguageName();
        setSubtitle($.basic, 0, languageName);
    }
    function updateDisplayedHttpTimeoutValue() {
        var httpTimeout = require("settings/changeHttpTimeout").getCurrentHttpTimeoutName();
        setSubtitle($.advanced, 0, httpTimeout);
    }
    function updateDisplayedTrackingValue() {
        var settings = Alloy.createCollection("AppSettings").settings();
        setHasCheck($.tracking, 1, settings.isTrackingEnabled());
    }
    function updateDisplayedGraphsValue() {
        var settings = Alloy.createCollection("AppSettings").settings();
        setHasCheck($.graphs, 2, settings.areGraphsEnabled());
    }
    function setTitle(section, itemIndex, title) {
        if (!supportsListView()) return uiRowIfTableView.setHasCheck(enabled);
        var item = section.getItemAt(itemIndex);
        item.properties.title = title;
        section.updateItemAt(itemIndex, item, {
            animated: true
        });
    }
    function setSubtitle(section, itemIndex, subtitle) {
        var item = section.getItemAt(itemIndex);
        item.properties.subtitle = subtitle;
        section.updateItemAt(itemIndex, item, {
            animated: true
        });
    }
    function setHasCheck(uiRowIfTableView, indexOfItemIfListView, enabled) {
        if (!supportsListView()) return uiRowIfTableView.setHasCheck(enabled);
        var item = $.basic.getItemAt(indexOfItemIfListView);
        enabled && false ? item.template = "checkedTemplate" : item.properties.accessoryType = enabled ? Ti.UI.LIST_ACCESSORY_TYPE_CHECKMARK : Ti.UI.LIST_ACCESSORY_TYPE_NONE;
        $.basic.updateItemAt(indexOfItemIfListView, item, {
            animated: true
        });
    }
    function updateAllDisplayedSettingsValues() {
        setTitle($.basic, 0, L("General_Language"));
        setTitle($.basic, 1, L("Mobile_AnonymousTracking"));
        setTitle($.basic, 2, L("Mobile_EnableGraphsLabel"));
        setTitle($.advanced, 0, L("Mobile_HttpTimeout"));
        updateDisplayedLanguageValue();
        updateDisplayedHttpTimeoutValue();
        updateDisplayedTrackingValue();
        updateDisplayedGraphsValue();
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.index = Ti.UI.createWindow({
        barImage: "navbar.png",
        backgroundColor: "#FFFFFF",
        barColor: "#CD1628",
        title: L("General_Settings"),
        backButtonTitle: L("Mobile_NavigationBack"),
        id: "index"
    });
    $.__views.index && $.addTopLevelView($.__views.index);
    onClose ? $.__views.index.addEventListener("close", onClose) : __defers["$.__views.index!close!onClose"] = true;
    onOpen ? $.__views.index.addEventListener("open", onOpen) : __defers["$.__views.index!open!onOpen"] = true;
    if (true && !Alloy.isTablet) {
        $.__views.__alloyId196 = Ti.UI.createButton({
            backgroundImage: "ic_action_menu.png",
            width: 32,
            height: 32,
            id: "__alloyId196"
        });
        toggleReportChooserVisibility ? $.__views.__alloyId196.addEventListener("click", toggleReportChooserVisibility) : __defers["$.__views.__alloyId196!click!toggleReportChooserVisibility"] = true;
        $.__views.index.leftNavButton = $.__views.__alloyId196;
    }
    $.__views.language = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        accessoryType: Ti.UI.LIST_ACCESSORY_TYPE_DISCLOSURE,
        template: Ti.UI.LIST_ITEM_TEMPLATE_SETTINGS,
        hasChild: true,
        title: L("General_Language"),
        id: "language"
    });
    var __alloyId222 = [];
    __alloyId222.push($.__views.language);
    changeLanguage ? $.__views.language.addEventListener("click", changeLanguage) : __defers["$.__views.language!click!changeLanguage"] = true;
    $.__views.tracking = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        hasCheck: true,
        title: L("Mobile_AnonymousTracking"),
        id: "tracking"
    });
    __alloyId222.push($.__views.tracking);
    toggleTrackingEnabled ? $.__views.tracking.addEventListener("click", toggleTrackingEnabled) : __defers["$.__views.tracking!click!toggleTrackingEnabled"] = true;
    $.__views.graphs = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        hasCheck: true,
        title: L("Mobile_EnableGraphsLabel"),
        id: "graphs"
    });
    __alloyId222.push($.__views.graphs);
    toggleGraphsEnabled ? $.__views.graphs.addEventListener("click", toggleGraphsEnabled) : __defers["$.__views.graphs!click!toggleGraphsEnabled"] = true;
    $.__views.advanced = Alloy.createWidget("org.piwik.tableviewsection", "widget", {
        title: L("Mobile_Advanced"),
        id: "advanced"
    });
    __alloyId222.push($.__views.advanced.getViewEx({
        recurse: true
    }));
    $.__views.timeout = Ti.UI.createTableViewRow({
        left: 10,
        right: 10,
        accessoryType: Ti.UI.LIST_ACCESSORY_TYPE_DISCLOSURE,
        template: Ti.UI.LIST_ITEM_TEMPLATE_SETTINGS,
        hasChild: true,
        title: L("Mobile_HttpTimeout"),
        id: "timeout"
    });
    __alloyId222.push($.__views.timeout);
    changeHttpTimeout ? $.__views.timeout.addEventListener("click", changeHttpTimeout) : __defers["$.__views.timeout!click!changeHttpTimeout"] = true;
    $.__views.settingsTable = Ti.UI.createTableView({
        data: __alloyId222,
        id: "settingsTable"
    });
    $.__views.index.add($.__views.settingsTable);
    $.__views.__alloyId221 = Ti.UI.createView({
        top: 10,
        bottom: 10,
        left: 0,
        right: 0,
        height: Ti.UI.SIZE,
        id: "__alloyId221"
    });
    $.__views.loginHint = Ti.UI.createLabel({
        color: "#7e7e7e",
        text: L("Mobile_LoginToPiwikToChangeSettings"),
        font: {
            fontWeight: "bold",
            fontSize: 14
        },
        left: 10,
        right: 10,
        id: "loginHint"
    });
    $.__views.__alloyId221.add($.__views.loginHint);
    $.__views.settingsTable.footerView = $.__views.__alloyId221;
    exports.destroy = function() {};
    _.extend($, $.__views);
    var callbacks = {
        changeLanguage: changeLanguage,
        toggleTrackingEnabled: toggleTrackingEnabled,
        toggleGraphsEnabled: toggleGraphsEnabled,
        changeHttpTimeout: changeHttpTimeout
    };
    exports.close = close;
    exports.open = function() {
        if (supportsListView()) {
            var settings = Alloy.createCollection("AppSettings").settings();
            settings.on("change", updateAllDisplayedSettingsValues);
            updateAllDisplayedSettingsValues();
        }
        require("layout").open($.index);
    };
    __defers["$.__views.index!close!onClose"] && $.__views.index.addEventListener("close", onClose);
    __defers["$.__views.index!open!onOpen"] && $.__views.index.addEventListener("open", onOpen);
    __defers["$.__views.__alloyId196!click!toggleReportChooserVisibility"] && $.__views.__alloyId196.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.__alloyId198!click!toggleReportChooserVisibility"] && $.__views.__alloyId198.addEventListener("click", toggleReportChooserVisibility);
    __defers["$.__views.headerBar!homeIconItemSelected!toggleReportChooserVisibility"] && $.__views.headerBar.on("homeIconItemSelected", toggleReportChooserVisibility);
    __defers["$.__views.settingsTable!itemclick!onItemClick"] && $.__views.settingsTable.addEventListener("itemclick", onItemClick);
    __defers["$.__views.language!click!changeLanguage"] && $.__views.language.addEventListener("click", changeLanguage);
    __defers["$.__views.tracking!click!toggleTrackingEnabled"] && $.__views.tracking.addEventListener("click", toggleTrackingEnabled);
    __defers["$.__views.graphs!click!toggleGraphsEnabled"] && $.__views.graphs.addEventListener("click", toggleGraphsEnabled);
    __defers["$.__views.timeout!click!changeHttpTimeout"] && $.__views.timeout.addEventListener("click", changeHttpTimeout);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;