exports.definition = {
    config: {
        columns: {
            value: "string"
        },
        adapter: {
            type: "piwikapi",
            collection_name: "piwiktokenauth"
        },
        settings: {
            method: "UsersManager.getTokenAuth",
            cache: false
        },
        defaultParams: {}
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            getPasswordHash: function(password) {
                return Ti.Utils.md5HexDigest(password);
            },
            getAnonymousLoginToken: function() {
                return "anonymous";
            },
            fetchToken: function(accountModel, username, password, onSuccess, onError) {
                if (username || password) {
                    var passwordHash = this.getPasswordHash(password);
                    this.fetch({
                        account: accountModel,
                        params: {
                            userLogin: username,
                            md5Password: passwordHash
                        },
                        success: onSuccess,
                        error: onError
                    });
                } else onSuccess(this, {
                    value: this.getAnonymousLoginToken()
                });
            },
            validResponse: function(response) {
                var _ = require("alloy/underscore");
                if (!response || !_.isObject(response) || !response.value) return false;
                return true;
            }
        });
        return Model;
    },
    extendCollection: function(Collection) {
        _.extend(Collection.prototype, {});
        return Collection;
    }
};

var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

model = Alloy.M("piwikTokenAuth", exports.definition, []);

collection = Alloy.C("piwikTokenAuth", exports.definition, model);

exports.Model = model;

exports.Collection = collection;