exports.definition = {
    config: {
        columns: {
            value: "string"
        },
        adapter: {
            type: "piwikapi",
            collection_name: "piwikversion"
        },
        settings: {
            method: "API.getPiwikVersion",
            cache: true,
            displayErrors: false
        },
        defaultParams: {
            limit: 1
        },
        defaults: {
            value: ""
        }
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            getVersion: function() {
                return this.get("value");
            }
        });
        return Model;
    },
    extendCollection: function(Collection) {
        _.extend(Collection.prototype, {});
        return Collection;
    }
};

var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

model = Alloy.M("piwikVersion", exports.definition, []);

collection = Alloy.C("piwikVersion", exports.definition, model);

exports.Model = model;

exports.Collection = collection;