exports.definition = {
    config: {
        columns: {
            idsite: "integer",
            name: "string",
            main_url: "string",
            ts_created: "string",
            timezone: "string",
            currency: "string",
            excluded_ips: "integer",
            excluded_parameters: "string",
            sitesearch: "integer",
            sitesearch_keyword_parameters: "string",
            sitesearch_category_parameters: "string",
            group: "string",
            ecommerce: "integer"
        },
        adapter: {
            type: "piwikapi",
            collection_name: "piwikwebsites"
        },
        settings: {
            method: "SitesManager.getSitesWithAtLeastViewAccess",
            cache: false
        },
        defaultParams: {}
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            idAttribute: "idsite",
            getName: function() {
                return this.get("name");
            },
            getSiteId: function() {
                return this.get("idsite");
            }
        });
        return Model;
    },
    extendCollection: function(Collection) {
        _.extend(Collection.prototype, {
            validResponse: function(response) {
                if (!response || !response[0]) return false;
                if (!response[0].idsite) return false;
                return true;
            }
        });
        return Collection;
    }
};

var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

model = Alloy.M("piwikWebsites", exports.definition, []);

collection = Alloy.C("piwikWebsites", exports.definition, model);

exports.Model = model;

exports.Collection = collection;