exports.definition = {
    config: {
        columns: {
            idsite: "integer",
            name: "string",
            main_url: "string",
            ts_created: "string",
            timezone: "string",
            currency: "string",
            excluded_ips: "integer",
            excluded_parameters: "string",
            sitesearch: "integer",
            sitesearch_keyword_parameters: "string",
            sitesearch_category_parameters: "string",
            group: "string",
            ecommerce: "integer"
        },
        adapter: {
            type: "piwikapi",
            collection_name: "piwikwebsitesbyid"
        },
        settings: {
            method: "SitesManager.getSiteFromId",
            cache: true
        },
        defaultParams: {}
    },
    extendModel: function(Model) {
        _.extend(Model.prototype, {
            idAttribute: "idsite"
        });
        return Model;
    },
    extendCollection: function(Collection) {
        _.extend(Collection.prototype, {
            entrySite: function() {
                var entrysite = this.first();
                var attributes = entrysite.toJSON();
                var siteModel = Alloy.createModel("PiwikWebsites", attributes);
                return siteModel;
            }
        });
        return Collection;
    }
};

var Alloy = require("alloy"), _ = require("alloy/underscore")._, model, collection;

model = Alloy.M("piwikWebsitesById", exports.definition, []);

collection = Alloy.C("piwikWebsitesById", exports.definition, model);

exports.Model = model;

exports.Collection = collection;