function InitAdapter() {}

function Sync(method, model, opts) {
    var settings = model.config.settings;
    var params = model.config.defaultParams;
    Ti.API.info("method " + method);
    switch (method) {
      case "read":
        var _ = require("alloy/underscore");
        var opts = _.clone(opts);
        opts.params && (params = _.extend(_.clone(params), opts.params));
        var PiwikApiRequest = require("Piwik/Network/PiwikApiRequest");
        var request = new PiwikApiRequest();
        request.setMethod(settings.method);
        request.setParameter(params);
        if (opts && opts.account) {
            request.setBaseUrl(opts.account.get("accessUrl"));
            request.setUserAuthToken(opts.account.get("tokenAuth"));
        }
        request.setCallback(function(response) {
            _.isUndefined(response) || _.isNull(response) ? opts.error && opts.error(model, {
                errorMessageDisplayed: this.errorMessageSent
            }) : _.isFunction(model.validResponse) && !model.validResponse(response) ? opts.error && opts.error(model, {
                errorMessageDisplayed: this.errorMessageSent
            }) : opts.success && opts.success(response);
            model = null;
        });
        false === settings.displayErrors && (request.sendErrors = false);
        request.send();
        request = null;
        break;

      case "create":
      case "update":
      case "delete":    }
}

module.exports.sync = Sync;

module.exports.beforeModelCreate = function(config) {
    config = config || {};
    config.data = {};
    InitAdapter(config);
    return config;
};

module.exports.afterModelCreate = function(Model) {
    Model = Model || {};
    Model.prototype.config.Model = Model;
    return Model;
};