function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "org.piwik.headerbar/" + s : s.substring(0, index) + "/org.piwik.headerbar/" + s.substring(index + 1);
    return path;
}

function Controller() {
    function addActionBarItem(actionBarItem, index) {
        if (!actionBarItem || !actionBarItem.icon) return;
        var item = Ti.UI.createImageView({
            image: actionBarItem.icon,
            top: "8dp",
            width: "32dp",
            height: "32dp",
            left: "8dp",
            right: "8dp",
            backgroundSelectedColor: "#a9a9a9"
        });
        item.addEventListener("click", function(event) {
            event.cancelBubble = true;
            $.trigger("actionItem" + index);
        });
        $.actionButtons.add(item);
        widthOfActionBarItem += 48;
    }
    function setHomeIcon(image) {
        $.homeIcon.backgroundImage = image;
        $.homeIcon.backgroundSelectedColor = "#a9a9a9";
    }
    function setDefaultHomeIcon() {
        setHomeIcon("/appicon.png");
    }
    function setTitle(title) {
        $.headerTitle.text = title || "";
    }
    function syncWidthOfTitleAndActionBar() {
        $.headerTitle.right = widthOfActionBarItem + "dp";
    }
    function enableBackButton() {
        $.backangle.backgroundImage = "/back.png";
        $.backangle.backgroundSelectedColor = "#a9a9a9";
        $.backangle.addEventListener("click", function(event) {
            event.cancelBubble = true;
            $.trigger("back");
        });
        $.homeIcon.addEventListener("click", function(event) {
            event.cancelBubble = true;
            $.trigger("back");
        });
    }
    function applyCustomProperties(args) {
        args.homeIcon ? setHomeIcon(args.homeIcon) : setDefaultHomeIcon();
        args.actionItem1 && addActionBarItem(args.actionItem1, 1);
        args.canGoBack && enableBackButton();
        syncWidthOfTitleAndActionBar();
        setTitle(args.title);
    }
    new (require("alloy/widget"))("org.piwik.headerbar");
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    exports.destroy = function() {};
    _.extend($, $.__views);
    var widthOfActionBarItem = 0;
    applyCustomProperties(arguments[0] || {});
    $.homeIcon.addEventListener("click", function(event) {
        event.cancelBubble = true;
        $.trigger("homeIconItemSelected");
    });
    exports.setTitle = setTitle;
    exports.resetHomeIcon = setDefaultHomeIcon;
    exports.enableCanGoBack = enableBackButton;
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;