function WPATH(s) {
    var index = s.lastIndexOf("/");
    var path = -1 === index ? "org.piwik.imageview/" + s : s.substring(0, index) + "/org.piwik.imageview/" + s.substring(index + 1);
    return path;
}

function Controller() {
    function loadImageViaXhr(imageView, urlToLoad) {
        var imageLoader = Ti.Network.createHTTPClient({
            validatesSecureCertificate: false,
            enableKeepAlive: false
        });
        imageLoader.open("GET", urlToLoad);
        imageLoader.onload = function() {
            imageView && this.responseData && (this.responseData.width || !supportsWidthDetectionOfImage) ? imageView.image = this.responseData : imageView && (imageView.image = errorImage);
            imageLoader = null;
            imageView = null;
        };
        imageLoader.onerror = function() {
            imageView && (imageView.image = errorImage);
            imageView = null;
            imageLoader = null;
        };
        imageLoader.send();
    }
    function userHasNoInternetConnection() {
        return !Ti.Network || !Ti.Network.online;
    }
    function startsNotWithHttp(url) {
        url = "" + url;
        url = url.toLowerCase();
        return -1 == url.indexOf("http");
    }
    function tryAlternativeDownloadMethod() {
        if (this.image && errorImage == this.image) return;
        if (!this.image || startsNotWithHttp(this.image)) {
            this.image = errorImage;
            return;
        }
        if (userHasNoInternetConnection()) {
            this.image = errorImage;
            return;
        }
        if (urlErrorHandled == this.image) {
            this.image = errorImage;
            return;
        }
        urlErrorHandled = this.image;
        loadImageViaXhr(this, this.image);
    }
    new (require("alloy/widget"))("org.piwik.imageview");
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    arguments[0] ? arguments[0]["__parentSymbol"] : null;
    arguments[0] ? arguments[0]["$model"] : null;
    arguments[0] ? arguments[0]["__itemTemplate"] : null;
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.image = Ti.UI.createImageView({
        id: "image"
    });
    $.__views.image && $.addTopLevelView($.__views.image);
    tryAlternativeDownloadMethod ? $.__views.image.addEventListener("error", tryAlternativeDownloadMethod) : __defers["$.__views.image!error!tryAlternativeDownloadMethod"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    var args = arguments[0] || {};
    var errorImage = "image_load_error.png";
    var supportsWidthDetectionOfImage = false;
    var urlErrorHandled = null;
    $.image.applyProperties(args);
    __defers["$.__views.image!error!tryAlternativeDownloadMethod"] && $.__views.image.addEventListener("error", tryAlternativeDownloadMethod);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;