function HandheldSidebar() {
    function createUnderlayWindow(left, right) {
        var underlayWindow = Ti.UI.createWindow({
            left: left,
            right: right,
            top: "48dp",
            zIndex: 997
        });
        return underlayWindow;
    }
    function createLeftUnderlayWindow() {
        var leftUnderlay = createUnderlayWindow(widthSidebar, 0);
        var separator = Ti.UI.createView({
            backgroundColor: "#000",
            left: 0,
            width: "2dp",
            height: Ti.UI.FILL
        });
        leftUnderlay.add(separator);
        var separator = Ti.UI.createView({
            backgroundColor: "#000",
            left: "2dp",
            opacity: .6,
            right: 0
        });
        leftUnderlay.add(separator);
        leftUnderlay.addEventListener("click", hideLeftSidebar);
        return leftUnderlay;
    }
    function createRightUnderlayWindow() {
        var rightUnderlay = createUnderlayWindow(0, widthSidebar);
        var separator = Ti.UI.createView({
            backgroundColor: "#000",
            right: 0,
            width: "2dp",
            height: Ti.UI.FILL
        });
        rightUnderlay.add(separator);
        var separator = Ti.UI.createView({
            backgroundColor: "#000",
            right: "2dp",
            opacity: .6,
            left: 0
        });
        rightUnderlay.add(separator);
        rightUnderlay.addEventListener("click", hideRightSidebar);
        return rightUnderlay;
    }
    function hideLeftSidebar() {
        if (leftSidebarWindow) {
            leftSidebarWindow.close();
            leftSidebarOuterWindow.close();
            leftSidebarWindow = null;
        }
    }
    function toggleLeftSidebar() {
        leftSidebarWindow ? hideLeftSidebar() : showLeftSidebar();
    }
    function showLeftSidebar() {
        if (leftSidebarWindow || !leftSidebarView) return;
        hideRightSidebar();
        leftSidebarWindow = Ti.UI.createWindow({
            left: 0,
            top: "48dp",
            width: widthSidebar,
            zIndex: 999
        });
        leftSidebarWindow.add(leftSidebarView);
        leftSidebarWindow.addEventListener("androidback", hideLeftSidebar);
        leftSidebarWindow.open();
        leftSidebarOuterWindow.open();
    }
    function hideRightSidebar() {
        if (rightSidebarWindow) {
            rightSidebarWindow.close();
            rightSidebarOuterWindow.close();
            rightSidebarWindow = null;
        }
    }
    function showRightSidebar() {
        if (rightSidebarWindow || !rightSidebarView) return;
        hideLeftSidebar();
        rightSidebarWindow = Ti.UI.createWindow({
            right: 0,
            top: "48dp",
            width: widthSidebar,
            zIndex: 998
        });
        rightSidebarWindow.add(rightSidebarView);
        rightSidebarWindow.addEventListener("androidback", hideRightSidebar);
        rightSidebarWindow.open();
        rightSidebarOuterWindow.open();
    }
    var leftSidebarView = null;
    var leftSidebarWindow = null;
    var leftSidebarOuterWindow = createLeftUnderlayWindow();
    this.setLeftSidebar = function(view) {
        leftSidebarView = view;
    };
    this.hideLeftSidebar = hideLeftSidebar;
    this.toggleLeftSidebar = toggleLeftSidebar;
    var rightSidebarView = null;
    var rightSidebarWindow = null;
    var rightSidebarOuterWindow = createRightUnderlayWindow();
    this.setRightSidebar = function(view) {
        rightSidebarView = view;
    };
    this.hideRightSidebar = hideRightSidebar;
    this.toggleRightSidebar = function() {
        rightSidebarWindow ? hideRightSidebar() : showRightSidebar();
    };
}

var widthSidebar = "250dp";

module.exports = HandheldSidebar;