function HandheldSidebar(detailRootWindow) {
    function hideLeftSidebar() {
        var animation = Ti.UI.createAnimation({
            left: 0,
            duration: 400,
            right: 0,
            curve: Ti.UI.ANIMATION_CURVE_EASE_IN_OUT
        });
        animation.addEventListener("complete", function() {
            leftSidebarWindow.hide();
            if (!leftSidebarOuterWindow) {
                console.warn("leftSidebarOuterWindow not set in layout");
                return;
            }
            leftSidebarOuterWindow.removeEventListener("click", hideLeftSidebar);
            leftSidebarOuterWindow.close();
            leftSidebarOuterWindow = null;
        });
        detailRootWindow.animate(animation);
        leftSidebarVisible = false;
    }
    function showLeftSidebar() {
        leftSidebarOuterWindow = Ti.UI.createWindow({
            left: widthSidebar,
            right: 0,
            backgroundColor: "transparent"
        });
        leftSidebarOuterWindow.addEventListener("click", hideLeftSidebar);
        leftSidebarOuterWindow.open();
        leftSidebarWindow.show();
        detailRootWindow.animate({
            left: widthSidebar,
            duration: 400,
            right: "-" + widthSidebar,
            curve: Ti.UI.ANIMATION_CURVE_EASE_IN_OUT
        });
        leftSidebarVisible = true;
    }
    function hideRightSidebar() {
        var animation = Ti.UI.createAnimation({
            left: 0,
            duration: 400,
            right: 0,
            curve: Ti.UI.ANIMATION_CURVE_EASE_IN_OUT
        });
        animation.addEventListener("complete", function() {
            rightSidebarWindow.hide();
            if (!rightSidebarOuterWindow) {
                console.warn("rightSidebarOuterWindow not set in layout");
                return;
            }
            rightSidebarOuterWindow.removeEventListener("click", hideRightSidebar);
            rightSidebarOuterWindow.close();
            rightSidebarOuterWindow = null;
        });
        detailRootWindow.animate(animation);
        rightSidebarVisible = false;
    }
    function showRightSidebar() {
        rightSidebarOuterWindow = Ti.UI.createWindow({
            left: 0,
            right: widthSidebar,
            backgroundColor: "transparent"
        });
        rightSidebarOuterWindow.addEventListener("click", hideRightSidebar);
        rightSidebarOuterWindow.open();
        rightSidebarWindow.show();
        detailRootWindow.animate({
            right: widthSidebar,
            duration: 400,
            left: "-" + widthSidebar,
            curve: Ti.UI.ANIMATION_CURVE_EASE_IN_OUT
        });
        rightSidebarVisible = true;
    }
    var leftSidebarWindow = Ti.UI.createWindow({
        left: 0,
        width: widthSidebar,
        visible: false
    });
    leftSidebarWindow.open();
    var leftSidebarOuterWindow;
    var leftSidebarVisible = false;
    this.setLeftSidebar = function(view) {
        leftSidebarWindow.add(view);
    };
    this.hideLeftSidebar = hideLeftSidebar;
    this.toggleLeftSidebar = function() {
        leftSidebarVisible ? hideLeftSidebar() : showLeftSidebar();
    };
    var rightSidebarWindow = Ti.UI.createWindow({
        right: 0,
        width: widthSidebar,
        visible: false
    });
    rightSidebarWindow.open();
    var rightSidebarOuterWindow;
    var rightSidebarVisible = false;
    this.setRightSidebar = function(view) {
        rightSidebarWindow.add(view);
    };
    this.hideRightSidebar = hideRightSidebar;
    this.toggleRightSidebar = function() {
        rightSidebarVisible ? hideRightSidebar() : showRightSidebar();
    };
}

var widthSidebar = 250;

module.exports = HandheldSidebar;